<?
// Wriiten by Spike^ekipS <spike@spikeekips.net>

//-------------------------------------------------- global include
include_once "./setting.php";

include_once $global["root"] . "/include/handle.php";
include_once $global["root"] . "/include/print_array.php";

include_once $global["root"] . "/lib/Site.php";
include_once $global["root"] . "/lib/Address.php";
include_once $global["root"] . "/lib/Authentication.php";

include_once sprintf("%s/lang/%s.php", $global["root"], $global["default_language"]);

$Auth = new Authentication;
$Auth->escape("_GET");

$Site = new Site;
$Site->connect_db();
$Site->start_session();

//-------------------------------------------------- argument parsing
if (! $_POST["address"] or trim($_POST["address"]) == "") {
	$_SESSION["tmp"]["msg"]["content"] = $string["error9"];
	$Site->end1();
	goprev();
}
if (! $_POST["password"] or trim($_POST["password"]) == "") {
	$_SESSION["tmp"]["msg"]["content"] = $string["error34"];
	$Site->end1();
	goprev();
}

$Address = new Address;
if (! $Address->check_valid($_POST["address"])) {
	$_SESSION["tmp"]["msg"]["content"] = $string["error10"];
	$Site->end1();
	goprev();
}

$Auth->set_address($_POST["address"]);
$var = $Auth->verify($_POST["password"]);

switch (intval($var)) {
	case (-3) : // global admin.
		include_once $global["root"] . "/lib/Authentication_Global.php";

		$Auth = new Authentication_Global($_POST["address"]);
		$Auth->assign();

		// if password is default value, go to update page.
		if ($_POST["password"] == "mesianpassword") {
			$url = sprintf("http://%s/global.php?mode=update_password",
				$_SESSION["config_domain"]);
		} else {
			$url = sprintf("http://%s/global.php", $_SESSION["config_domain"]);
		}

		Header("Location: " . $url);
		exit;
	break;

	case (2) : // holded user.
		$_SESSION["tmp"]["msg"]["content"] = $string["login4"];
		$_SESSION["tmp"]["msg"]["type"] = "2";

		$Site->force_logout();
	break;

	case (1) : // normal user and postmaster.
		include_once $global["root"] . "/lib/Authentication_User.php";

		//------------------------------ session registering.
		// register to $_SESSION
		$Auth = new Authentication_User($_POST["address"]);
		$Auth->assign();

		$url = sprintf("http://%s/mail.php", $_SESSION["config_www_name"]);

		$Site->end();

		Header("Location: " . $url);
		exit;
	break;

	default : // failed to authenticate.
		$_SESSION["tmp"]["msg"]["content"] = $string["login3"];

		$Site->end1();
		goprev();
}

?>
