<?
include_once $global["root"] . "/lib/Item.php";

class myDirectory {

	var $DB;
	var $no;

	var $parent = "0";
	var $depth = "1";
	var $esc;
	var $mark = "-";

	var $compact = false;

	var $action;
	var $items;

	//-------------------------------------------------- sql
	var $SQL_INSERT_DIRECTORY =
			"insert into directory_%s (name, parent) values('%s','%s')";
	var $SQL_DELETE_DIRECTORY = "delete from directory_%s where no = '%s'";
	var $SQL_DELETE_DIRECTORY1 = "delete from directory_%s where %s";
	var $SQL_GET_PARENT = "select SQL_CACHE no,parent from directory_%s";
	var $SQL_RENAME_DIRECTORY =
			"update directory_%s set name = '%s' where no = '%s'";
	var $SQL_DIRECTORY_NAME_BY_ITEM =
			"select SQL_CACHE directory_num from item_%s
				where item_num = '%s' and item_type = '%s'";
	var $SQL_GET_DIRECTORY_NAME =
			"select SQL_CACHE name from directory_%s where no = '%s'";
	var $SQL_GET_DIRECTORY_CONFIG =
			"select SQL_CACHE %s from directory_%s where no = '%s'";
	var $SQL_GET_PARENT_DIRECTORY =
			"select SQL_CACHE name, parent from directory_%s where no = '%s'";
	var $SQL_GET_NUM_ITEMS =
			"select SQL_CACHE count(no) as nums from item_%s
				where directory_num = '%s'";
	var $SQL_GET_SUBDIRECTORY =
			"select SQL_CACHE no, name from directory_%s where parent = '%s'";
	var $SQL_GET_DIRECTORY =
			"select SQL_CACHE no from directory_%s";
	var $SQL_DIRECTORY_LIST =
			"select SQL_CACHE no, item_type, item_num
				from item_%s where directory_num = '%s'";
	var $SQL_GET_ITEM_IN_DIRECTORY = "select no, item_num, item_type from item_%s
			where %s";

	var $system;

	//================================================== constructor
	function myDirectory ($no="0") {
		global $global;

		if ($no != "") $this->no = "$no";

		$this->system = array_flip($global["directory"]);
	}

	//-------------------------------------------------- directory action.
	// call this method first before you do some action.
	function set_DB () {
		$DB = new MySQLdb;
	}

	function is_system ($no="") {
		global $global;

		if (! $no) $no = "$this->no";

		$a = array_flip($global["directory"]);

		if (array_key_exists($no, $a) or ! $no) {
			$retval = true;
		} else {
			$retval = false;
		}

		return $retval;
	}

	// get all the number of directories.
	function get_directory_no () {
		global $global;

		$DB = new MySQLdb;

		$o = $DB->fetch_all(
				sprintf("select no from directory_%s order by no",
				$_SESSION["config_id"])
			);

		$retval = array_map("fetch_directory_no", $o);

		return $retval;
	}

	function add ($name) {
		global $global;

		$DB = new MySQLdb;

		// add directory in mydirectory.
		if (! $this->no) $this->no = $global["directory"]["mydirectory"];

		$directory_name = addslashes(htmlspecialchars(trim($name)));

		$DB->query(sprintf($this->SQL_INSERT_DIRECTORY,
				$_SESSION["config_id"], $directory_name, $this->no));

		$retval = $DB->retval;

		return $retval;

	}

	function remove_item ($no) {

		$DB = new MySQLdb;

		// -------------------------------------------------- move items to trash.
		$DB->query(sprintf($this->SQL_DIRECTORY_LIST,
			$_SESSION["config_id"], $no), true);

		$Item = new Item();
		for ($i = 0; $i < $DB->num_rows; $i++) {
			$o = $DB->fetch();

			$Item->set($o["no"]);
			$Item->remove(false);
		}
	}

	function remove () {
		global $global;

		$a = array_flip($global["directory"]);

		if (array_key_exists($this->no, $a)) {
			$retval = false;
		} else {
			$DB = new MySQLdb;

			$this->remove_item($this->no);

			$DB->query(sprintf($this->SQL_DELETE_DIRECTORY,
				$_SESSION["config_id"], $this->no));

			if ($DB->retval) {
				$this->remove_orphan(); // remove all sub directories.
			}

			$retval = $DB->retval;
		}

		return $retval;

	}

	function remove_orphan () {

		$DB = new MySQLdb;

		$a = $this->get_orphan(); // remove all sub directories.

		if (! is_array($a)) {
			$DB->retval = true;
			$retval = true;
		} else {
			while (list($i, $j) = each($a)) {
				$b[] = sprintf("no = '%s'", $i);

				$this->remove_item($j);
			}

			$c = implode(" or ", $b);

			// remove
			$DB->query(sprintf($this->SQL_DELETE_DIRECTORY1,
				$_SESSION["config_id"], $c));

			$retval = $DB->retval;
		}

		return $retval;
	}

	function rename ($new_name) {

		$DB = new MySQLdb;
		$name = addslashes(htmlspecialchars(trim($new_name)));

		$DB->query(sprintf($this->SQL_RENAME_DIRECTORY,
			$_SESSION["config_id"], $name, $this->no));

		return $retval;

	}

	//-------------------------------------------------- get info.

	function get_orphan () {

		$DB = new MySQLdb;

		$DB->query(sprintf($this->SQL_GET_PARENT,
			$_SESSION["config_id"]), true);

		for ($i = 0; $i < $DB->num_rows; $i++) {
			$a = $DB->fetch();
			$b[$a["no"]] = $a["parent"];
		}

		if (! is_array($b)) {
			$retval = false;
		} else {
			while (list($i, $j) = each($b)) {
				if ($j == "0") continue;

				if ($orphan) {
					if (array_key_exists($j, $orphan)) {
						$orphan[$i] = $j;
					}
				}

				if (!array_key_exists($j, $b)) {
					$orphan[$i] = $j;
				}
			}

			$retval = $orphan;
		}

		return $retval;
	}

	function get_name ($no=False) {
		global $global, $string;

		$DB = new MySQLdb;

		if ($no) $this->no = $no;
		if (! $this->no) $this->no = "0";

		if ($this->no == "0") {
			$retval = $string["item16"];
		} else {

			$g = array_flip($global["directory"]);

			if (array_key_exists($this->no, $g)) {
				$retval = $string["directory" . $this->no];
			} else {
				$a = $DB->fetch_one(sprintf($this->SQL_GET_DIRECTORY_NAME,
						$_SESSION["config_id"], $this->no));

				$retval = $a["name"];
			}
		}

		return $retval;
	}

	function get_name_by_module ($item_num, $item_type) {

		$DB = new MySQLdb;
		$DB->query(sprintf($this->SQL_DIRECTORY_NAME_BY_ITEM,
			$_SESSION["config_id"], $item_num, $item_type), true);

		for ($i = 0; $i < $DB->num_rows; $i++) {
			$o = $DB->fetch();

			$this->no = $o["directory_num"];
			$a[] = array("name" => $this->get_name(), "no" => $o["directory_num"]);
		}

		$retval = $a;

		return $retval;

	}

	function get_parent () {

		$DB = new MySQLdb;
		$retval = $DB->fetch_one(sprintf($this->SQL_GET_PARENT_DIRECTORY,
				$_SESSION["config_id"], $this->no));

		return $retval;
	}

	function get_parent_list () {

		$DB = new MySQLdb;

		if ($this->no == "0") {
			$retval = false;
		} else {
			$b[] = $this->no;
			$a = $this->get_parent();
			$b[] = $a["parent"];

			while ($a["parent"] != "0" and $a["parent"]) {

				$this->no = $a["parent"];
				$a = $this->get_parent();
				$b[] = $a["parent"];
			}

			sort($b);
			reset($b);

			$retval = $b;
		}

		return $retval;
	}

	function get_nums_item () {

		$DB = new MySQLdb;
		$a = $DB->fetch_one(sprintf($this->SQL_GET_NUM_ITEMS,
			$_SESSION["config_id"], $this->no));

		$retval = $a["nums"];

		return $retval;
	}

	var $SQL_GET_ITEM_NUM_WITH_FLAG_TYPE =
		"select count(type.no) as nums from item_%s as item, %s_%s as type
			where item.directory_num = '%s' and
				(item.item_type = %s and item.item_num = type.no) and (type.flag = %s)";

	var $SQL_GET_ITEM_NUM_BY_TYPE =
		"select count(type.no) as nums from item_%s as item, %s_%s as type
			where item.directory_num = '%s' and
				(item.item_type = %s and item.item_num = type.no)";

	function __get_num_item_by_item_type ($item_type) {

		$DB = new MySQLdb;

		// get item number.
		$query = sprintf($this->SQL_GET_ITEM_NUM_BY_TYPE,
			$_SESSION["config_id"],
			$_SESSION["user_item_type_table"][$item_type],
			$_SESSION["config_id"],
			$this->no,
			$item_type
		);

		$o = $DB->fetch_one($query);

		$var = 0;
		if (array_key_exists("nums", $o)) $var = $o["nums"];

		return $var;
	}

	function __get_num_item_by_item_type_flag ($item_type, $flag) {

		$DB = new MySQLdb;

		// get item number by flag.
		$query = sprintf($this->SQL_GET_ITEM_NUM_WITH_FLAG_TYPE,
			$_SESSION["config_id"],
			$_SESSION["user_item_type_table"][$item_type],
			$_SESSION["config_id"],
			$this->no,
			$item_type,
			$flag
		);

		$o = $DB->fetch_one($query);

		$var = 0;
		if (array_key_exists("nums", $o)) $var = $o["nums"];

		return $var;
	}

	function get_num_item_by_item_type ($no="", $item_type=false) {
		/*
		@rtype : array
			array["total"] = ..
			array[item type number ] = ..
			array[item type number ][flag number] = ..
		*/

		if ($no) $this->no = $no;

		// get total item number in this directory.
		$var["total"] = $this->get_nums_item();

		// initiate
		if ($item_type) {
			$type[$item_type]["total"] = 0;
		} else {
			$a = $_SESSION["user_item_type"];
			while (list($i, $j) = each($a)) $type[$i]["total"] = 0;
		}

		// get the number of item by item type.
		if ($var["total"] > 0) {
			$a = $type;

			while (list($i, $j) = each($a)) {

				$o = $this->__get_num_item_by_item_type($i);
				$var[$i]["total"] = $o;

				// if message type, check the flag.
				if ($i == $_SESSION["user_item_type_rv"]["message"]) {
					$p = $this->__get_num_item_by_item_type_flag($i, "0"); // unread
					$q = $this->__get_num_item_by_item_type_flag($i, "1"); // read

					$var[$i]["0"] = $p;
					$var[$i]["1"] = $q;
				}
			}
		}

		return $var;
	}

	function get_info_subdirectory () {

		$DB = new MySQLdb;

		if (! $this->no) $this->no = "0";

		$DB->query(sprintf($this->SQL_GET_SUBDIRECTORY,
				$_SESSION["config_id"], $this->no), true);

		if ($DB->num_rows < 1) {
			$retval = array();
		} else {
			for ($i = 0; $i < $DB->num_rows; $i++) {
				$o = $DB->fetch();

				while (list($j, $k) = each($o)) {
					$a[$o["no"]][$j] = $k;
				}
			}

			$retval = $a;
		}

		return $retval;
	}

	/*
	function get_total_size () {

		$DB = new MySQLdb;

		$DB->query(sprintf($this->SQL_GET_DIRECTORY,
				$_SESSION["config_id"]), true);

		for ($i = 0; $i < $DB->num_rows; $i++) {
			$o = $DB->fetch();

			$this->no = $o["no"];
			$a += $this->get_size();
		}

		$retval = $a;

		return $retval;
	}
	*/

	function get_total_size () {
		$DB = new MySQLdb;

		$size = 0;

		// get total size of message
		$o = $DB->fetch_one(
			sprintf("select sum(size) as size from mail_entireMessage_%s",
				$_SESSION["config_id"])
		);
		$size += $o["size"];

		// get total size of document
		$o = $DB->fetch_one(
			sprintf("select sum(size) as size from doc_%s",
				$_SESSION["config_id"])
		);
		$size += $o["size"];

		// get the number of card.
		$o = $DB->fetch_one(
			sprintf("select count(no) as nums from card_%s",
				$_SESSION["config_id"])
		);
		$size += $o["nums"] * 10000; // one card approximately is 10kb.

		return $size;
	}

	// $no : directory number
	function get_size () {
		global $global, $string;

		$DB = new MySQLdb;
		$DB->query(sprintf($this->SQL_DIRECTORY_LIST,
			$_SESSION["config_id"], $this->no), true);

		$Item = new Item();

		for ($i = 0; $i < $DB->num_rows; $i++) {
			$o = $DB->fetch();

			$a[$o["item_type"]][] = $o["item_num"];
		}

		if (count($a) < 1) {
			$c = 0;
		} else {
			while (list($i, $j) = each($a)) {
				$b = $Item->get_size($j, $i);
				if (! $b) continue;

				$c += $b;
			}
		}

		$retval = $c;

		return $retval;
	}

	function get_item ($item_type="") {

		$DB = new MySQLdb;

		if ($this->no) $q[] = sprintf("(directory_num = '%s')", $this->no);
		if ($item_type) $q[] = sprintf("(item_type = '%s')", $item_type);

		$add_query = implode(" and ", $q);

		$DB->query(sprintf($this->SQL_GET_ITEM_IN_DIRECTORY,
			$_SESSION["config_id"], $add_query), true);

		$data = array();
		for ($i = 0; $i < $DB->num_rows; $i++) {
			$o = $DB->fetch();

			$data[$o["no"]]["item_num"] = $o["item_num"];
			$data[$o["no"]]["item_type"] = $o["item_type"];
		}

		$retval = $data;

		return $retval;
	}
}

function remove_system_directory ($var) {
	global $global;

	$a = array_flip($global["directory"]);

	return (! array_key_exists($var["no"], $a));

}

function fetch_directory_no ($var) {
	return ($var["no"]);
}

/*
Description
-----------

Author
------
 Spike^ekipS <spike@spikeekips.net>

Changelog
---------

Usage
-----

*/

?>
