<?

function get_query_from_url ($url) {

	$a = parse_url($url);

	if ($a["query"]) {
		$b = explode("&", $a["query"]);

		while (list($i, $j) = each($b)) {
			$c = explode("=", $j);
			if (count($c) < 1) {
				$arg[$c[0]] = "";
			} else {
				$arg[$c[0]] = $c[1];
			}
		}
	}

	if (is_array($arg)) {
		$retval = $arg;
	} else {
		$retval = array();
	}

	return $retval;
}

class HTTP_lib {

	var $URL;

	function HTTP_lib ($url="") {
		if ($url) $this->URL = $url;
	}

	function get_query ($url="") {

		if (! $url) $url = $this->URL;

		$retval = get_query_from_url($url);

		return $retval;
	}

	function get_url_except_this ($arguement_key, $url="") {

		if (! $url) $url = $this->URL;

		$b = parse_url($url);
		$a = $this->get_query($url);

		if (! array_key_exists($arguement_key, $a)) {
			$retval = $url;
		} else {
			unset($a[$arguement_key]);

			// re-generate query
			while (list($i, $j) = each($a)) {
				$c[] = sprintf("%s=%s", $i, $j);
			}

			$query = implode("&", $c);

			$url = "";

			// re-generate url
			if ($b["host"]) $url = sprintf("http://%s", $b["host"]);

			if ($b["path"]) $url = sprintf("%s%s", $url, $b["path"]);

			$url = sprintf("%s?%s", $url, $query);

			if ($b["fragment"]) $url = sprintf("#%s", $url, $b["fragment"]);

			$retval = $url;

		}

		return $retval;
	}

}

/*
Description
-----------

Author
------
 Spike^ekipS <spike@spikeekips.net>

Changelog
---------

Usage
-----

*/

?>
