<?

include_once "./setting.php";

include_once $global["root"] . "/include/handle.php";
include_once $global["root"] . "/include/print_array.php";

//-------------------------------------------------- protection
include_once $global["root"] . "/lib/Site.php";
include_once $global["root"] . "/lib/User.php";
include_once $global["root"] . "/lib/Address.php";

$Site = new Site;
$Site->init();
$Site->set_permission("user");

include_once $global["lang"] . "/" . $_SESSION["config_lang"] . ".php";

// make query
if (strlen(trim($_POST["add_new"])) > 2) { // add new

	$A = new Address; // check whether is valid name or not.
	if (! $A->check_valid(sprintf("%s@%s",
			trim($_POST["add_new"]), $_SESSION["config_domain"])) ) {

		$_SESSION["tmp"]["msg"]["content"] = $string["error10"];
		$Site->end1();
		goprev();
	} else {
		// check whether the maximum number allowed will be reached or not.
		$U = new User;
		$fake_address = $U->get_fake();

		if (intval($_SESSION["config_fake_address_limit"]) <= count($fake_address)) {
			$_SESSION["tmp"]["msg"]["content"] = sprintf($string["error26"], $_SESSION["config_fake_address_limit"]);
			$Site->end1();
			goprev();
		}

		// check whether new fake name is duplicated or not.
		if ($U->is_duplicated($_POST["add_new"], $_SESSION["config_domain"])) {
			$_SESSION["tmp"]["msg"]["content"] = $string["error15"];
			$Site->end1();
			goprev();
		}

		$query[] =
			sprintf("insert into user_alias_priv (name, domain, user_no, valid, is_fake)
					values('%s','%s','%s', '1','1')",
				escape_string(trim($_POST["add_new"])),
				$_SESSION["config_domain"], $_SESSION["config_no"]);
	}

} else if (count($_POST["invalid"]) > 0) { // set invalid
	while (list($i, $j) = each($_POST["invalid"])){
		$a[] = sprintf("no = '%s'", $j);
		$b[] = sprintf("no != '%s'", $j);
	}

	$query[] = sprintf("update user_alias_priv set valid = '0'
		where (%s) and (user_no = '%s' and is_fake = '1')",
			implode(" or ", $a), $_SESSION["config_no"]);
	$query[] = sprintf("update user_alias_priv set valid = '1'
		where (%s) and (user_no = '%s' and is_fake = '1')",
			implode(" and ", $b), $_SESSION["config_no"]);

} else if (count($_POST["remove"]) > 0) { // set remove
	while (list($i, $j) = each($_POST["remove"])){
		$a[] = sprintf("no = '%s'", $j);
	}

	$query[] = sprintf("delete from user_alias_priv where %s", implode(" or ", $a));

} else {
	$query[] = sprintf("update user_alias_priv set valid = '1'
		where (user_no = '%s' and is_fake = '1')", $_SESSION["config_no"]);
}

$Site->DB->transaction_start(true);

$retval = true;
while (list($i, $j) = each($query)) {
	if (! $retval) break;

	$Site->DB->query($j);

	$retval = $Site->DB->retval;
}

$Site->DB->retval = $retval;

$Site->DB->close();

if ($retval) {
	$url = "Location: " . $_SESSION["user_global_url"] .
		"/mail.php?mode=control&control=1&no=4";

	$Site->end1();

	Header($url);
	exit;
} else {
	$Site->end1();
	goprev();
}

/*
Description
-----------

Author
------
 Spike^ekipS <spike@spikeekips.net>

Changelog
---------

Usage
-----

*/

?>
