<?

function __return_array_for_group_item ($str) {

	if (trim($str) != "") {
		$b = array_unique(explode(",", $str));

		$retval = array_filter($b, "__is_valid_value_for_array_filter");

		sort($retval);
	} else {
		$retval = array();
	}

	return $retval;
}

function __is_valid_value_for_array_filter ($var) {
	return (trim($var) != "");
}

/////////////////////////////////////////////////////////
// check and calculate item in card_group table.

function __add_item ($new_array, $org_array) {
	$e = array_unique(array_merge($new_array, $org_array));

	sort($e);

	return $e;
}

function __remove_item ($new_array, $dst_array) {

	$f = array_intersect($dst_array, $new_array);
	$g = array_diff($dst_array, $f);

	sort($g);

	return $g;
}

/*
Description
-----------

Author
------
 Ekips, Bae <spike@spikeekips.net>

Changelog
---------

Usage
-----

*/

?>
