<?
//
// Wriiten by Spike^ekipS <spike@spikeekips.net>
// нtimestamp  · մϴ.
function print_time($timestamp, $lang="", $full=false) {

	if ($lang == "english") {
		$format0 = "Today %I:%M %p"; // hour:miniute am/pm
		$format1 = "%e, %I:%M";
		$format2 = "%m.%e %H oclock"; // month day hour:miniute am/pm
		$format3 = "%Y.%m.%e"; // year. month day
		$format4 = "%Y.%m.%e %I:%M %p";// year. month day hour:miniute am/pm
	} else {
		setlocale(LC_ALL, "ko_KR");
		$format0 = " %p %I %M";
		$format1 = "%e %p %I";
		$format2 = "%m %e %I";
		$format3 = "%Y %m %e";
		$format4 = "%Y %m %e %p %I%M";
	}

	if ($timestamp == "email") {
		// Tue, 07 Oct 2003 11:42:24 +0000
		setlocale(LC_ALL, "en_US");
		$result = gmstrftime("%a, %d %b %Y %T") . " " . date("O");
	} else if ($full) {
		$result = strftime($format4, $timestamp);
	} else {
		$today = mktime(0,0);
		$this_month = mktime(0,0,0, date("n"), 1);
		$this_year = mktime(0,0,0,1,1);

		if ($timestamp > $today) {
			$result = strftime($format0, $timestamp);

		} else if ($timestamp > $this_month) {
			$result = strftime($format1, $timestamp);

		} else if ($timestamp > $this_year) {
			$result = strftime($format2, $timestamp);

		} else {
			$result = strftime($format3, $timestamp);
		}
	}

	return $result;
}

?>
