<?

include_once $global["root"] . "/lib/MySQLdb.php";

class Address {

	var $SQL_CHECK_DUPL =
		"select SQL_CACHE count(no) as num from mail_block_%s where address = '%s'";

	var $SQL_INSERT_BLOCK = "insert into mail_block_%s (address) values('%s')";

	var $SQL_REMOVE_BLOCK = "delete from mail_block_%s where address = '%s'";
	var $SQL_REMOVE_BLOCK1 = "delete from mail_block_%s where no = '%s'";
	var $SQL_GET_NUM_BLOCKED_ADDRESS =
		"select SQL_CACHE count(no) as num from mail_block_%s";
	var $REG_ADDRESS =
		"<[a-z0-9._#-][a-z0-9._#-]*@[a-z0-9-][a-z0-9-]*[a-z0-9.-][a-z0-9.-]*.[a-z0-9][a-z0-9]*>";

	var $address;
	var $is_valid;

	function Address ($address="") {
		if ($address) {
			$this->address = $address;
			$this->check_valid();
		}
	}

	function get_blocked_number () {
		$DB = new MySQLdb;
		$o = $DB->fetch_one(
			sprintf($this->SQL_GET_NUM_BLOCKED_ADDRESS, $_SESSION["config_id"]));

		return intval($o["num"]);
	}

	function block_add ($address="") {
		/*
			retval,
				-1 : is duplicated.
				false : failed
				true : success
		*/

		if (! $address) {
			$address = $this->address;
		}

		if ((intval($_SESSION["config_block_address"]) !== -1) and
				($this->get_blocked_number() >= intval($_SESSION["config_block_address"]))) {
			$retval = -2;
		} else if ($this->__check_duplicated_in_block($address)) {
			$retval = -1;
		} else {
			$DB = new MySQLdb;

			$DB->transaction_start(true);

			// insert into DB.
			$DB->query(sprintf($this->SQL_INSERT_BLOCK, $_SESSION["config_id"], $address));

			$retval = $DB->retval;

			$DB->close();
		}

		return $retval;
	}

	function block_remove ($address="", $no="") {

		if (! $address) {
			$address = $this->address;
		} else {
			$this->address = $address;
		}

		$DB = new MySQLdb;

		$DB->transaction_start(true);
		if ($no) {
			$DB->query(sprintf($this->SQL_REMOVE_BLOCK1, $_SESSION["config_id"], $no));
		} else {
			$DB->query(sprintf($this->SQL_REMOVE_BLOCK, $_SESSION["config_id"], $address));
		}

		$retval = $DB->retval;

		$DB->close();

		return $retval;
	}

	function __check_duplicated_in_block ($address="") {

		if (! $address) {
			$address = $this->address;
		} else {
			$this->address = $address;
		}

		$DB = new MySQLdb;

		// find duplicated or not.
		$o = $DB->fetch_one(sprintf($this->SQL_CHECK_DUPL, $_SESSION["config_id"], $address));

		if ($o["num"] > 0) {
			$retval = true;
		} else {
			$retval = false;
		}

		return $retval;
	}

	function return_split ($address="") {

		if (! $address) {
			$address = $this->address;
		} else {
			$this->address = $address;
		}

		$address = trim($address);

		// handling 'From' field

		// this code does not handle the broken letters.
		//if (eregi($this->REG_ADDRESS, $address)) {

		$c = explode("<", $address);

		if (is_array($c) and count($c) > 1) {


			if (! trim($c[0])) {
				$d = trim(str_replace(">","", $c[1]));

				$e = explode("@", $d);
				$one["short"] = $e[0];
				$one["full"] = $d;
			} else {
				$e = trim($c[0]);
				$d = trim(str_replace(">","", $c[1]));

				$one["short"] = ereg_replace("[\"|\']", "", $e);
				$one["full"] = $d;
			}
		} else {
			$a = explode("@", $address);
			$address1 = $a[0];

			$one["short"] = $address1;
			$one["full"] = $address;
		}

		$retval = $one;

		return $retval;
	}

	function check_valid ($address="") {

		if ($address) $this->address = $address;

		$a = explode(",", $this->address);

		$retval = true;
		while (list($i, $j) = each($a)) {
			if (! $retval) break;

			if (eregi("^[a-z0-9._#-][a-z0-9._#-]*@[a-z0-9-][a-z0-9-]*[a-z0-9.-][a-z0-9.-]*.[a-z0-9][a-z0-9]*$",
			$j)) {
				$this->is_valiad = true;
				$retval = true;
			} else {
				$this->is_valiad = false;
				$retval = false;
			}
		}

		return $retval;
	}

	function check_valid_domain ($domain) {

		if (eregi("^[a-z0-9][a-z0-9]*[a-z0-9.-][a-z0-9.-]*\.[a-z0-9][a-z0-9]*$", $domain)) {
			$retval = true;
		} else {
			$retval = false;
		}

		return $retval;
	}

}

/*
Description
-----------

Author
------
 Spike^ekipS <spike@spikeekips.net>

Changelog
---------

Usage
-----

*/

?>
