<?

include_once $global["root"] . "/include/message/etc.php";
include_once $global["root"] . "/include/print_time.php";

include_once $global["root"] . "/lib/Template.php";
include_once $global["root"] . "/lib/Address.php";
include_once $global["root"] . "/lib/Directory.php";
include_once $global["root"] . "/lib/Item.php";
include_once $global["root"] . "/lib/Card_Group.php";

class Basic_card {

	// SQL
	var $SQL_GET_ITEM = "select SQL_CACHE * from card_%s where no = '%s'";
	var $SQL_INSERT_ITEMS_TO_MODULE = "insert into card_%s
			(name, email, work_phone, home_phone, fax,
			mobile, zip_work, country_work, city_work,
			add_work, title_work, department_work,
			organization_work, zip_home, country_home,
			city_home, add_home, homepage, comment)
		values('%s', '%s', '%s', '%s', '%s', '%s', '%s',
			'%s', '%s', '%s', '%s', '%s', '%s', '%s', '%s',
			'%s', '%s', '%s', '%s')";
	var $SQL_REMOVE_CARD_ITEM = "delete from card_%s where no = '%s'";
	var $SQL_SEARCH_CARD = "select SQL_CACHE no from card_%s where %s";
	var $SQL_SEARCH_CARD_ARRAY = "select SQL_CACHE no from card_%s where (%s) and (%s)";
	var $SQL_GET_SIZE =
		"select SQL_CACHE sum(length(name) + length(email) +
					length(work_phone) + length(home_phone) +
					length(fax) + length(mobile) +
					length(zip_work) + length(country_work) +
					length(city_work) + length(add_work) +
					length(title_work) + length(department_work) +
					length(organization_work) + length(zip_home) +
					length(country_home) + length(city_home) +
					length(add_home) + length(homepage) +
					length(comment)) as size from card_%s where %s";
	/*var $SQL_GET_CARD =
			"select SQL_CACHE
				name, email, work_phone, home_phone, fax, mobile, zip_work, country_work,
				city_work, add_work, title_work, department_work, organization_work,
				zip_home, country_home, city_home, add_home, homepage, comment, date
				from card_%s where no = '%s'";
	*/
	var $SQL_GET_CARD =
			"select SQL_CACHE
				name, email, work_phone, home_phone, fax, mobile, zip_work, country_work,
				city_work, add_work, title_work, department_work, organization_work,
				zip_home, country_home, city_home, add_home, homepage, comment, date
				from card_%s where no = '%s'";

	var $SQL_GET_EMAIL = "select SQL_CACHE email from card_%s where no = '%s'";

	var $SQL_GET_CARD_GROUP = "select SQL_CACHE no, name from card_group_%s";

	//-------------------------------------------------- action
	// $no is directory number.
	/*
	function add ($directory_num) {
		return $retval;
	}
	*/

	function Basic_Card () {
		$this->Template = new Template;
	}

	function add ($directory_num) {
		global $global, $string;

		$a["directory_num"] = $directory_num;

		if ($_GET["email"]) $a["email"] = $_GET["email"];
		if ($_GET["name"]) $a["name"] = $_GET["name"];

		$retval = $this->Template->generate("card/add", $a);

		return $retval;
	}

	function edit ($no) {
		global $global, $string;

		$this->Template = new Template;
		$DB = new MySQLdb;

		$o = $DB->fetch_one(sprintf($this->SQL_GET_CARD, $_SESSION["config_id"], $no));

		$main = escapeHTMLCode($o);
		$main["no"] = $no;

		$retval =
			$this->Template->generate("card/edit", $main);

		return $retval;
	}

	function copy ($no) {

		$DB = new MySQLdb;

		//------------ fetch from original data.
		$a = $DB->fetch_one(sprintf($this->SQL_GET_ITEM, $_SESSION["config_id"], $no));

		if (! $a["name"]) {
			$retval = false;
		} else {
			//------------ insert same data into doc_%s.
			$DB->query(sprintf($this->SQL_INSERT_ITEMS_TO_MODULE,
				$_SESSION["config_id"],
					addslashes($a["name"]), addslashes($a["email"]),
					addslashes($a["work_phone"]), addslashes($a["home_phone"]),
					addslashes($a["fax"]), addslashes($a["mobile"]),
					addslashes($a["zip_work"]), addslashes($a["country_work"]),
					addslashes($a["city_work"]), addslashes($a["add_work"]),
					addslashes($a["title_work"]), addslashes($a["department_work"]),
					addslashes($a["organization_work"]), addslashes($a["zip_home"]),
					addslashes($a["country_home"]), addslashes($a["city_home"]),
					addslashes($a["add_home"]), addslashes($a["homepage"]),
					addslashes($a["comment"])));

			$retval = $DB->retval;
		}

		if ($retval) {
			$retval = $DB->get_last_insert_id();
		}

		return $retval;
	}

	function remove ($no) {

		$DB = new MySQLdb;
		$DB->query(sprintf($this->SQL_REMOVE_CARD_ITEM, $_SESSION["config_id"], $no));

		$retval = $DB->retval;

		return $retval;
	}

	function get_email ($no) {

		$DB = new MySQLdb;

		$o = $DB->fetch_one(sprintf($this->SQL_GET_EMAIL, $_SESSION["config_id"], $no));

		if (! $o["email"]) {
			$retval = false;
		} else {
			$retval = trim($o["email"]);
		}

		return $retval;
	}

	function info ($no) {
		global $global, $string;

		$DB = new MySQLdb;
		$o = $DB->fetch_one(sprintf($this->SQL_GET_CARD, $_SESSION["config_id"], $no));

		if (! $o["name"]) {
			$a = false;
		} else {
			$author = $o["name"];

			if ($o["mobile"]) {
				$b[0] = $o["mobile"];
			} else if ($o["work_phone"]) {
				$b[0] = $o["work_phone"];
			} else if ($o["home_phone"]) {
				$b[0] = $o["home_phone"];
			} else if ($o["fax"]) {
				$b[0] = $o["fax"];
			}

			if ($o["email"]) $b[1] = $o["email"];

			if (! $o["email"] and ! $b) {
				$a["title"] = sprintf("<span class=\"read\">%s</span>", $string["card28"]);
			} else {
				$a["title"] = sprintf("%s", implode(" - ", $b));
			}

			$a["createdTime"] = $o["date"];

			$a["author"]["short"] = $o["name"];
			$a["author"]["full"] = $o["email"];

			$a["flag"] = ""; // card does not have read/unread state, it's just a card.
		}

		$retval = $a;

		return $retval;
	}

	function size ($no) {

		if (! is_array($no)) {
			$retval = 100;
		} else {
			$retval = 100 * count($no);
		}

		return $retval;
	}

	function search ($str, $case="", $group="a") {
		global $global, $string;

		$DB = new MySQLdb;

		$a = preg_split("/ \t*/", $str);

		$col = array("name", "email", "work_phone", "home_phone", "fax",
					"mobile", "zip_work", "country_work", "city_work",
					"add_work", "title_work", "department_work",
					"organization_work", "zip_home", "country_home",
					"city_home", "add_home", "homepage", "comment");

		if ($case) {
			while (list($i, $j) = each($col)) {
				$c[] = sprintf("%s regexp binary '%s'", $j, $str);
			}
		} else {
			$b = "%" . addslashes(implode("%", $a)) . "%";

			while (list($i, $j) = each($col)) {
				$c[] = sprintf("%s like '%s'", $j, $b);
			}
		}

		$d = implode(" or ", $c);

		// get card item in group.
		$CG = new Card_Group($group);
		$c = $CG->get_item("a");
		while (list($i, $j) = each($c)) $c_list[] = sprintf("no = '%s'", $j);

		if (count($c_list) < 1) {
			$add_query = $d;
		} else {
			$add_query = sprintf("(%s) and (%s)", $d, implode(" or ", $c_list));
		}

		$DB->query(
			sprintf($this->SQL_SEARCH_CARD, $_SESSION["config_id"], $add_query), true);

		$data = array();
		for ($i =0; $i < $DB->num_rows; $i++) {
			$o = $DB->fetch();

			$data[] = $o["no"];
		}

		$retval = $data;

		return $retval;
	}

	function search_array ($str, $data, $case="") {
		global $global, $string;

		$a = preg_split("/ \t*/", $str);

		$col = array("name", "email", "work_phone", "home_phone", "fax",
					"mobile", "zip_work", "country_work", "city_work",
					"add_work", "title_work", "department_work",
					"organization_work", "zip_home", "country_home",
					"city_home", "add_home", "homepage", "comment");

		if ($case) {
			while (list($i, $j) = each($col)) {
				$c[] = sprintf("%s regexp binary '%s'", $j, $str);
			}
		} else {
			$b = "%" . addslashes(implode("%", $a)) . "%";

			while (list($i, $j) = each($col)) {
				$c[] = sprintf("%s like '%s'", $j, $b);
			}
		}

		$DB = new MySQLdb;

		$n = array_keys($data);
		while (list($i, $j) = each($n)) $nn[] = sprintf("no = '%s'", $j);
		$numbers = implode(" or ", $nn);

		$d = implode(" or ", $c);

		$DB->query(
			sprintf($this->SQL_SEARCH_CARD_ARRAY, $_SESSION["config_id"], $numbers, $d), true);

		$no = array();
		for ($i =0; $i < $DB->num_rows; $i++) {
			$o = $DB->fetch();

			$no[$data[$o["no"]]["no"]]["no"] = $o["no"];
			$no[$data[$o["no"]]["no"]]["item_type"] =
				$_SESSION["user_item_type_rv"]["card"];
		}

		$retval = $no;

		return $retval;

	}

	function make_read ($no) {
		return true;
	}

}

/*
Description
-----------

Author
------
 Spike^ekipS <spike@spikeekips.net>

Changelog
---------

Usage
-----

*/

?>
