<?

include_once $global["root"] . "/lib/Directory.php";
include_once $global["root"] . "/include/group.php";
include_once $global["root"] . "/lib/Basic_Card_Group.php";

class Card_Group {

	var $group_no;

	var $SQL_GET_GROUP_ALL = "select SQL_CACHE no,name,item from card_group_%s";
	var $SQL_GET_GROUP = "select SQL_CACHE no,name,item from card_group_%s where no = '%s'";
	var $SQL_GET_GROUP_NAME = "select SQL_CACHE name from card_group_%s where no = '%s'";
	var $SQL_GET_ITEM_ALL = "select SQL_CACHE distinct item from card_group_%s";
	var $SQL_CHECK_ITEM = "select SQL_CACHE no from card_%s where no = '%s'";

	function Card_Group ($no="") {
		if ($no) $this->group_no = $no;
	}

	function get_name ($group_no) {
		global $string;

		if ($group_no == "a") {
			$retval = $string["card41"];
		} else if ($group_no == "trash") {
			$retval = $string["directory5"];
		} else {
			$DB = new MySQLdb;

			$o = $DB->fetch_one(
				sprintf(
					$this->SQL_GET_GROUP_NAME,
					$_SESSION["config_id"],
					$group_no
				)
			);

			if (! $o) {
				$retval = "";
			} else {
				$retval = $o["name"];
			}
		}

		return $retval;
	}

	function get_item ($no="") {

		if (! $no and $this->group_no) $no = $this->group_no;

		$DB = new MySQLdb;

		$data = array();
		if ($no == "a") {
			$Directory = new myDirectory;
			$o = $Directory->get_item($_SESSION["user_item_type_rv"]["card"]);

			while (list($i, $j) = each($o)) {
				$data[] = $j["item_num"];
			}
		} else {
			$o = $DB->fetch_one(sprintf($this->SQL_GET_GROUP, $_SESSION["config_id"], $no));

			$data = __return_array_for_group_item($o["item"]);
		}

		$retval = $data;

		return $retval;
	}

	function get_info ($no="") {

		if (! $no and $this->group_no) $no = $this->group_no;

		/*
		return value is array
			array[no] = no, string
			array[name] = name, string
			array[item] = item, array
		*/
		$DB = new MySQLdb;

		$o = $DB->fetch_one(sprintf($this->SQL_GET_GROUP, $_SESSION["config_id"], $no));

		if (! $o["no"]) {
			$retval = array();
		} else {
			$var["no"] = $o["no"];
			$var["name"] = $o["name"];
			$var["item"] = __return_array_for_group_item($o["item"]);

			$retval = $var;
		}

		return $retval;
	}

	function get_list () {
		/*
		return value is array
			array[no][name] = string
			array[no][item] = array
		*/
		$DB = new MySQLdb;

		$DB->query(sprintf($this->SQL_GET_GROUP_ALL, $_SESSION["config_id"]), true);

		for ($i = 0; $i < $DB->num_rows; $i++) {
			$o = $DB->fetch();
			$var[$o["no"]]["name"] = $o["name"];
			$var[$o["no"]]["item"] = __return_array_for_group_item($o["item"]);
		}

		return $var;
	}

	function get_address ($no="") {
		global $global;

		if (! $no and $this->group_no) $no = $this->group_no;

		$o = $this->get_info($no);

		if (count($o["item"]) < 1) {
			$retval = false;
		} else {
			include_once $global["root"] . "/lib/Basic_card.php";

			$Card = new Basic_card;
			while (list($i, $j) = each($o["item"])) {
				$a[] = $Card->get_email($j);
			}

			$retval = array_unique($a);
		}

		return $retval;
	}

	function check_group_item_valid ($no="") {

		if ($no) $this->group_no = $no;

		if ($this->group_no == "a") { // get all items.
			$DB = new MySQLdb;
			$DB->query(sprintf($this->SQL_GET_ITEM_ALL, $_SESSION["config_id"]), true);

			for ($i = 0; $i < $DB->num_rows; $i++) {
				$o = $DB->fetch();
				$a[] = $o["item"];
			}

			$item_list = __return_array_for_group_item(implode(",", $a));

		} else {
			$a = $this->get_info();
			$item_list = $a["item"];
		}

		if (count($item_list) > 0) {
			// get orphan items.
			$orphan = array();
			while (list($i, $j) = each($item_list)) {
				if (! $this->check_item_valid($j)) {
					$b[] = $j;
				}
			}
		}

		// remove orphan items.
		if (count($b) > 0) {
			$orphan = implode(",", $b);

			$CG = new Basic_Card_Group;
			$CG->remove_item($this->group_no, $orphan);
		}

		return true;
	}

	function check_item_valid ($no) {

		$DB = new MySQLdb;
		$o = $DB->fetch_one(
			sprintf($this->SQL_CHECK_ITEM, $_SESSION["config_id"], $no), true);

		if ($o["no"]) {
			$retval = true;
		} else {
			$retval = false;
		}

		return $retval;
	}
}

/*
Description
-----------

Author
------
 Spike^ekipS <spike@spikeekips.net>

Changelog
---------

Usage
-----

*/

?>
