<?

include_once $global["root"] . "/lib/Card_Group.php";
include_once $global["root"] . "/lib/Basic_card.php";
include_once $global["root"] . "/lib/Basic_card.php";

class Extend_Card_Group {

	var $Group;

	function Extend_Card_Group () {

		$this->Group = new Card_Group;
		$this->Template = new Template;
	}

	function return_management () {

		$list = $this->Group->get_list();

		while (list($i, $j) = each($list)) {
			$var["name"] = $j["name"];
			$var["no"] = $i;
			$var["number_of_items"] = count($j["item"]);

			$main["content"] .= $this->Template->generate(
					"card/card_group_list_one",
					$var
				);
		}

		$retval = $this->Template->generate(
				"card/card_group_list",
				$main
			);

		return $retval;

	}

	function return_select_box ($action="", $items="") {
		global $global, $string;

		//-------------------------------------------------- root
		// set label.
		switch ($action) {
			case ("copy") :
				$main["button_label"] = $string["item52"];
			break;
			case ("move") :
				$main["button_label"] = $string["item49"];
			break;
		}

		$a = $this->Group->get_list();

		while (list($i, $j) = each($a)) {

			$var["no"] = $i;
			$var["name"] = $j["name"];

			if ($_SESSION["user_card_group_no"] == $i) {
				$template =
					"card/card_group_select_box_list_one_not_active";
			} else {
				$template = "card/card_group_select_box_list_one";
			}

			$main["content"] .= $this->Template->generate($template, $var);
		}

		$main["action"] = $action;
		$main["items"] = implode(",", $items);
		$main["group_no"] = $_SESSION["user_card_group_no"];

		$retval = $this->Template->generate(
				"card/card_group_select_box_list",
				$main
			);

		return $retval;
	}

	function return_search_result ($str, $case="", $pg="0") {

		$Card = new Basic_card;
		$items = $Card->search($str, $case, $_SESSION["user_card_group_no"]);

		$Card = new Basic_card;

		while (list($i, $j) = each($items)) {

			// make list line.
			$o = $Card->info($j);

			if (! $o["title"]) continue;
			$one["item_no"] = $item_no;

			$one["no"] = $j;
			$one["group_no"] = $this->group_no;
			$one["email"] = $o["title"];
			$one["name"] = $o["author"]["short"];
			$one["createdTime"] = print_time($o["createdTime"], $_SESSION["config_lang"]);

			$ret["content"] .=
				$this->Template->generate("card/card_list_one_search", $one);
		}

		$main["str"] = htmlspecialchars($str);

		// item list menu
		$tmpl_suffix = "_search";

		if ($this->empty) {
			$item_list_menu_template =
				sprintf("card/action_menu_not_active%s", $tmpl_suffix);
		} else {
			$item_list_menu_template =
				sprintf("card/action_menu%s", $tmpl_suffix);
		}

		// item list sub-menu
		if ($this->empty) {
			$item_list_menu_sub_template =
				sprintf("card/action_menu_sub_not_active%s", $tmpl_suffix);
		} else {
			$item_list_menu_sub_template =
				sprintf("card/action_menu_sub%s", $tmpl_suffix);
			$item_list_menu_sub2_template =
				sprintf("card/action_menu_sub2%s", $tmpl_suffix);
		}

		$main["item_list_menu"] = $this->Template->generate($item_list_menu_template);
		$main["item_list_menu_sub"] =
			$this->Template->generate($item_list_menu_sub_template);
		$main["item_list_menu_sub2"] =
			$this->Template->generate($item_list_menu_sub2_template);

		$main["content"] = $this->Template->generate("card/card_list_search", $ret);

		$retval = $this->Template->generate("card/list_search", $main);

		return $retval;

	}
}

/*
Description
-----------

Author
------
 Spike^ekipS <spike@spikeekips.net>

Changelog
---------

Usage
-----

*/

?>
