<?

include_once $global["root"] . "/lib/Domains.php";
include_once $global["root"] . "/lib/Extend_message.php";
include_once $global["root"] . "/lib/Template.php";

class Request_Postmaster {

	var $handler_list =
		array("user_list", "user_info", "domain", "mail_configuration");

	function Request_Postmaster () {
		$this->Template = new Template;
	}

	// domain admin
	function user_list ($pg=0, $pg_alias) {

		$Domains = new Domains;

		return $Domains->return_user_list($pg, $pg_alias);
	}

	function user_info ($no) {

		$Domains = new Domains;

		return $Domains->return_user_info($no);
	}

	function mail_configuration () {
		$Domains = new Domains;

		return $Domains->return_mail_configuration();
	}

	function domain_configuration () {
		$Domains = new Domains;

		return $Domains->return_domain_configuration();
	}

	function check_handler ($mode="") {
		if (! $mode) {
			$retval = false;
		} else {
			if (! in_array($mode, $this->handler_list)) {
				$retval = false;
			} else {
				$retval = true;
			}
		}

		return $retval;
	}

	function handle () {

		extract($_GET);

		switch ($mode) {
			case ("user_list") :
				$main["content"] = $this->user_list($_GET["pg"], $_GET["pg_alias"]);
			break;

			case ("user_info") :
				$main["content"] = $this->user_info($no);
			break;

			case ("mail_configuration") :
				$main["content"] = $this->mail_configuration();
			break;

			case ("domain") :
				$main["content"] = $this->domain_configuration();
			break;
		}

		if (array_key_exists("content", $main)) {
			$this->entire_page = true;

			$main["domain"] = $_SESSION["config_domain"];
			$retval = $this->Template->generate("global/domain/main", $main);
		} else {
			$retval = false;
		}

		return $retval;
	}

}

/*
Description
-----------

Author
------
 Spike^ekipS <spike@spikeekips.net>

Changelog
---------

Usage
-----

*/

?>
