# -*- coding: utf-8 -*-
import os, popen2
import config, mySMTP

class Send :

	__smtp = None

	def __init__ (self) :

		if config.default["send"] == "smtp" :
			try :
				self.__smtp = mySMTP.mySMTP(config.smtp)
			except :
				pass

	def __thru_smtp (self, From, To, message) :

		try :
			self.__smtp.sendmail(From=From, To=To, msg=message)
		except :
			retval = False
		else :
			retval = True

		return retval

	def __thru_qmail_inject (self, message) :

		# pre 0.6, to use qmail-inject, we use os.popen3()
		# pro 0.6, we use popen2.Popen3 to get the exit code of qmail-inject.

		try :
			Child = popen2.Popen3("%s/qmail-inject" % config.qmail["directory"]["bin"], 1)
			Child.tochild.write(message)
			Child.tochild.close()
			retval = Child.wait()
		except :
			retval = False
		else :
			if retval == 0 :
				retval = True
			else :
				retval = False

		return retval

	def send (self, **kwd) :

		if config.default["send"] == "smtp" :
			if not kwd.has_key("message") :
				retval = False
			elif not kwd.has_key("To") :
				retval = False
			elif not kwd.has_key("From") :
				retval = False
			else :
				retval = self.__thru_smtp(kwd["From"], kwd["To"], kwd["message"])
		else :
			if not kwd.has_key("message") :
				retval = False
			else :
				retval = self.__thru_qmail_inject(kwd["message"])

		return retval


__author__ =  "Spike^ekipS <spike@spikeekips.net>"
__version__=  "0.1"
__nonsense__ = ""

__file__ = "Send.py"

