<?
// Wriiten by Spike^ekipS <spike@spikeekips.net>
include_once $global["root"] . "/include/message/etc.php";
include_once $global["root"] . "/include/message/do.php";
include_once $global["root"] . "/include/message/parseContent.php";

include_once $global["root"] . "/include/print_time.php";

class Basic_message {

	var $Template;

	var $SQL_GET_MAIL_ITEM =
		"select SQL_CACHE
			header, headerSimple, textBody, htmlBody, payload,
			headerPayload, cid, headerCid, entireMessage, isPayload, isCid,
			flag, date from mail_%s where no = '%s'";
	var $SQL_GET_ENTIREMESSAGE =
			"select SQL_CACHE message from mail_entireMessage_%s where no = '%s'";
	var $SQL_GET_ENTIREMESSAGE_BY_MAIL_NO =
			"select SQL_CACHE t1.message as message
				from mail_entireMessage_%s as t1, mail_%s as t2
				where t1.no = t2.entireMessage and t2.no = '%s'";
	var $SQL_INSERT_ENTIREMESSAGE =
			"insert into mail_entireMessage_%s (message) values('%s')";
	var $SQL_GET_MAIL_INFO =
		"select SQL_CACHE headerSimple, date, flag, type, notified, checkedTime, message_id
			from mail_%s where no = '%s'";
	var $SQL_GET_REMOVE_ITEM =
			"select SQL_CACHE cid, payload, entireMessage from mail_%s where no = '%s'";
	var $SQL_REMOVE_MAIL = "delete from mail_%s where no = '%s'";
	var $SQL_REMOVE_ENTIREMESSAGE =
			"delete from mail_entireMessage_%s where no = '%s'";
	var $SQL_SEARCH_MAIL =
			"select SQL_CACHE no from mail_%s where (%s) and (%s)";
	var $SQL_GET_SIZE_ITEM =
		"select SQL_CACHE sum(t2.size) as size
			from mail_%s as t1, mail_entireMessage_%s as t2
			where %s and t1.entireMessage = t2.no";
	var $SQL_UPDATE_READ = "update mail_%s set flag = '1' where no = '%s'";

	//-------------------------------------------------- function
	function Basic_message () {
		$this->Template = new Template;
	}

	function copy ($no) {

		$DB = new MySQLdb;

		//------------ fetch from original message.
		$c = $DB->fetch_one(sprintf($this->SQL_GET_MAIL_ITEM, $_SESSION["config_id"], $no));
		//------------

		if (! $c["header"]) {
			$retval = false;
		} else {
			//------------ get entiremessage from mail_entireMessage_%s.
			$d = $DB->fetch_one(sprintf($this->SQL_GET_ENTIREMESSAGE,
				$_SESSION["config_id"], $c["entireMessage"]));

			//------------ insert same data into mail_%s.
			$DB->query(sprintf($this->SQL_INSERT_ENTIREMESSAGE,
					$_SESSION["config_id"], addslashes($d["message"])));

			$retval = $DB->retval;

			if ($retval) {
				//------------ insert same data into mail_%s.
				$DB->query(sprintf($this->SQL_INSERT_ITEMS_TO_MODULE,
					$_SESSION["config_id"],
						addslashes($c["header"]), addslashes($c["headerSimple"]),
						addslashes($c["textBody"]), addslashes($c["htmlBody"]),
						addslashes($c["payload"]), addslashes($c["headerPayload"]),
						addslashes($c["cid"]), addslashes($c["headerCid"]),
						$c["isPayload"], $c["isCid"], $c["flag"], $c["date"]));

				$retval = $DB->retval;
			}
		}

		if ($retval) $retval = $DB->get_last_insert_id();

		return $retval;
	}

	function info ($no, $type=false) {
		global $global, $string;

		$retval = $this->__info($no, $_SESSION["config_id"]);

		return $retval;
	}

	function info2 ($no, $type=false) {
		global $global, $string;

		$retval = $this->__info($no, "unKnown");

		return $retval;
	}

	function __info ($no, $id) {
		global $global, $string;

		$DB = new MySQLdb;

		$o = $DB->fetch_one(sprintf($this->SQL_GET_MAIL_INFO, $id, $no));

		if (! is_array($o)) {
			$b = false;
		} else {
			$a = parseHeader($o["headerSimple"]);

			if (trim($a["subject"]) == "") $a["subject"] = $string["message1"];

			$b["createdTime"] = $o["date"];
			$b["checkedTime"] = $o["checkedTime"];
			$b["message_id"] = $o["message_id"];

			$b["flag"] = $o["flag"];
			$b["type"] = $o["type"];

			$b["title"] = htmlspecialchars($a["subject"]);

			$Address = new Address();

			// inbox or sent?
			if (
					$_SESSION["user_directory"] == $global["directory"]["sent"] or
					$_SESSION["user_directory"] == $global["directory"]["draft"]
					) {
				$b["author"] = $Address->return_split($a["to"]);
			} else {
				$b["author"] = $Address->return_split($a["from"]);
			}
		}

		$retval = $b;

		return $retval;
	}

	function remove ($no) {
		global $global;

		$DB = new MySQLdb;

		$o = $DB->fetch_one(sprintf($this->SQL_GET_REMOVE_ITEM,
				$_SESSION["config_id"], $no));

		$DB->query(sprintf($this->SQL_REMOVE_MAIL, $_SESSION["config_id"], $no));
		$retval = $DB->retval;

		if ($retval) {
			$DB->query(sprintf($this->SQL_REMOVE_ENTIREMESSAGE,
				$_SESSION["config_id"], $o["entireMessage"]));
			$retval = $DB->retval;
		}

		# remove cid & payload file in data directory.
		if ($retval) {
			if ($o["cid"]) {
				$a = explode(";", $o["cid"]);

				while (list($i, $j) = each($a)) {
					$filename = sprintf("%s/cid/%s/%s",
						$global["data"], $_SESSION["config_id"], $j);
					if (file_exists($filename)) unlink($filename);
				}
			}

			if ($o["payload"]) {
				$a = explode(";", $o["payload"]);

				while (list($i, $j) = each($a)) {
					$filename = sprintf("%s/payload/%s/%s",
						$global["data"], $_SESSION["config_id"], $j);

					if (file_exists($filename)) unlink($filename);
				}
			}
		}

		return $retval;
	}

	function search_array ($str, $data, $case="") {
		global $global, $string;

		// $all is just list all.
		$a = preg_split("/ \t*/", $str);

		$col = array("headerSimple", "textBody", "htmlBody", "entireMessage");

		if ($case) {
			while (list($i, $j) = each($col)) {
				$c[] = sprintf("%s regexp binary '%s'", $j, addslashes($str));
			}
		} else {
			$b = "%" . addslashes(implode("%", $a)) . "%";
			while (list($i, $j) = each($col)) {
				$c[] = sprintf("%s like '%s'", $j, $b);
			}
		}

		$d = implode(" or ", $c);

		$n = array_keys($data);
		while (list($i, $j) = each($n)) $nn[] = sprintf("no = '%s'", $j);

		$numbers = implode(" or ", $nn);

		$DB = new MySQLdb;
		$DB->query(sprintf($this->SQL_SEARCH_MAIL,
					$_SESSION["config_id"], $numbers, $d), true);

		$no = array();
		for ($i =0; $i < $DB->num_rows; $i++) {
			$o = $DB->fetch();

			$no[$data[$o["no"]]["no"]]["no"] = $o["no"];
			$no[$data[$o["no"]]["no"]]["item_type"] =
				$_SESSION["user_item_type_rv"]["message"];
		}

		$retval = $no;

		return $retval;
	}

	function make_read ($no) {

		$DB = new MySQLdb;

		$DB->query(sprintf($this->SQL_UPDATE_READ, $_SESSION["config_id"], $no));

		return true;
	}

	function size ($no) {

		$DB = new MySQLdb;

		if (! is_array($no)) {
			$a = sprintf("t1.no = '%s'", $no);
		} else {
			while (list($i, $j) = each($no)) {
				$b[] = sprintf("t1.no = '%s'", $j);
			}
			$a = sprintf("(%s)", implode(" or ", $b));
		}

		$o = $DB->fetch_one(sprintf($this->SQL_GET_SIZE_ITEM,
				$_SESSION["config_id"],$_SESSION["config_id"], $a));

		$retval = $o["size"];

		return $retval;
	}

	function get_entireMessage ($no) {
		$DB = new MySQLdb;

		$o = $DB->fetch_one(
			sprintf($this->SQL_GET_ENTIREMESSAGE_BY_MAIL_NO,
				$_SESSION["config_id"], $_SESSION["config_id"], $no));

		if ($o["message"]) {
			$retval = $o["message"];
		} else {
			$retval = false;
		}

		return $retval;
	}
}

/*
Description
-----------

Author
------
 Spike^ekipS <spike@spikeekips.net>

Changelog
---------

Usage
-----

*/

?>
