<?

include_once $global["root"] . "/lib/Doc_Group.php";

class Extend_Doc_Group {

	var $Group;

	function Extend_Doc_Group () {

		$this->Group = new Doc_Group;
		$this->Template = new Template;
	}

	function return_management () {

		$list = $this->Group->get_list();

		if (count($list) < 1) {
			$main["content"] = "";
		} else {
			while (list($i, $j) = each($list)) {
				$var["name"] = $j["name"];
				$var["no"] = $i;
				$var["number_of_items"] = count($j["item"]);

				$main["content"] .= $this->Template->generate(
						"doc/doc_group_list_one",
						$var
					);
			}
		}

		$retval = $this->Template->generate(
				"doc/doc_group_list",
				$main
			);

		return $retval;

	}

	function return_select_box ($action="", $items="") {
		global $global, $string;

		//-------------------------------------------------- root
		// set label.
		switch ($action) {
			case ("copy") :
				$main["button_label"] = $string["item52"];
			break;
			case ("move") :
				$main["button_label"] = $string["item49"];
			break;
		}

		$a = $this->Group->get_list();

		while (list($i, $j) = each($a)) {

			$var["no"] = $i;
			$var["name"] = $j["name"];

			if ($_SESSION["user_doc_group_no"] === $i) {
				$template =
					"doc/doc_group_select_box_list_one_not_active";
			} else {
				$template = "doc/doc_group_select_box_list_one";
			}

			$main["content"] .= $this->Template->generate($template, $var);
		}

		$main["action"] = $action;
		$main["items"] = implode(",", $items);
		$main["group_no"] = $_SESSION["user_doc_group_no"];

		$retval = $this->Template->generate(
				"doc/doc_group_select_box_list",
				$main
			);

		return $retval;
	}
}

/*
Description
-----------

Author
------
 Spike^ekipS <spike@spikeekips.net>

Changelog
---------

Usage
-----

*/

?>
