# -*- coding: utf-8 -*-
import os, sys, signal

class Null:
	def write(self, data):
		pass

def get_qmaild_uid () :

	u_qmaild = False

	a, b, c = os.popen3("/usr/bin/id -u qmaild")

	if len(c.readlines()) > 1 :
		sys.stderr.writelines("This script must be run as user, 'qmaild'\n")
		sys.stderr.writelines("Please check your environment, etc) /etc/passwd.\n")
		sys.exit(1)
	else :
		u_qmaild = int(b.readlines()[0].strip())

	return u_qmaild

def fork_this (**kwd) :

	uid = False
	pid = False

	# check uid
	if kwd.has_key("uid") :
		uid = kwd["uid"]

	# check pid file.
	if kwd.has_key("pid") :
		pid = kwd["pid"]

	signal.signal(signal.SIGCHLD, signal.SIG_IGN)

	sig = os.fork()

	if sig != 0 :
		os._exit(0)
	else :
		if pid :
			if os.path.exists(pid) :
				sys.stderr.write("pid file, %s is already exists. Check it.\n" % pid)
				sys.exit(1)
			else :
				#-------------------------------------------------- make a pid file
				try :
					f = open(pid, "w")
					f.write("%s" % os.getpid())
					f.close()
				except :
					sys.stderr.write("\nCan not create pid file, %s\n" % pid)
					sys.exit(1)

	os.setsid()

	if uid : os.setuid(uid)

	os.umask(0)
	sys.stdin.close()

	nullDevice = Null()

	sys.stdout = sys.__stdout__ = nullDevice
	sys.stderr = sys.__stderr__ = nullDevice

__author__ =  "Spike^ekipS <spike@spikeekips.net>"
__version__=  "0.1"
__nonsense__ = ""

__file__ = "mySystem.py"

