# -*- coding: utf-8 -*-
import os, xmlrpclib

import config

class myXML :

	tables_scheme = None
	tables_data = None

	def set_tables_xml (self) :

		tables_scheme = "%s/etc/tables.xml" % (config.mail_server["root"])

		if not os.path.exists(tables_scheme) :
			self.tables_data = False
		else :
			self.tables_data = "".join(open(tables_scheme).readlines())

	def get_table_scheme (self) :
		"""
		@rtype : dict
		"""

		if not self.tables_data :
			retval = dict()
		else :
			try :
				a = xmlrpclib.loads(self.tables_data)
			except :
				retval = dict()
			else :
				retval = a[0][0]

		return retval

"""
Description
-----------


ChangeLog
---------


Usage
-----


"""

__author__ =  "Spike^ekipS <spike@spikeekips.net>"
__version__=  "0.1"
__nonsense__ = ""

__file__ = "myXML.py"


