<?
// Wriiten by Spike^ekipS <spike@spikeekips.net>

include_once "./setting.php";

// include
include_once $global["root"] . "/include/handle.php";
include_once $global["root"] . "/include/print_array.php";

// lib
include_once $global["root"] . "/lib/Site.php";
include_once $global["root"] . "/lib/Authentication.php";
include_once $global["root"] . "/lib/User.php";

$Site = new Site;
$Site->init("_GET");

$Site->set_permission("postmaster");

extract($_POST);

include_once $global["lang"] . "/" . $_SESSION["config_lang"] . ".php";

$Site->DB->transaction_start(true);

switch ($_POST["action"]) {

	case ("save") :

		$retval = true;

		$User = new User;

		//////////////////////////////////////////////////// user
		// set valid
		if (is_array($_POST["valid"])) {
			while (list($i, $j) = each($_POST["valid"])) {
				if ($j == "0") {
					$retval = $User->set_not_valid($i);
				} else {
					$retval = $User->set_valid($i);
				}

				if (! $retval) break;
			}
		}

		// remove
		if ($retval and is_array($_POST["remove"])) {

			$a = $_POST["remove"];
			while (list($i, $j) = each($a)) {
				$retval = $User->remove($i, $j);

				if (! $retval) break;
			}

		}

		//////////////////////////////////////////////////// user alias
		// set valid
		if (is_array($_POST["valid_alias"])) {
			while (list($i, $j) = each($_POST["valid_alias"])) {
				if ($j == "0") {
					$retval = $User->set_not_valid_alias($i);
				} else {
					$retval = $User->set_valid_alias($i);
				}

				if (! $retval) break;
			}
		}

		// remove
		if ($retval and is_array($_POST["remove_alias"])) {

			while (list($i, $j) = each($_POST["remove_alias"])) {
				$retval = $User->remove_alias($j);

				if (! $retval) break;
			}
		}
		////////////////////////////////////////////////////

		if (! $retval) {
			$_SESSION["tmp"]["msg"]["content"] = $string["msg1"];
		} else {
			$_SESSION["tmp"]["msg"]["content"] = $string["msg"];
			$_SESSION["tmp"]["msg"]["type"] = "2";
		}

	break;

	case ("make_new_user") :
		$User = new User;

		$retval = $User->add($_POST["new_username"],
			$_SESSION["config_domain"], $_POST["user_password"]);

		switch (true) {
			case (strval($retval) == "-2") :
				$_SESSION["tmp"]["msg"]["content"] = $string["error15"];
			break;
			case (strval($retval) == "-3") :
				$_SESSION["tmp"]["msg"]["content"] = $string["error16"];
			break;
			case (strval($retval) == "-4") :
				$_SESSION["tmp"]["msg"]["content"] =
					sprintf($string["error25"], $_SESSION["config_user_limit"]);
			break;
			case ($retval == true) :
				$_SESSION["tmp"]["msg"]["content"] = $string["msg3"];
				$_SESSION["tmp"]["msg"]["type"] = 2;
			break;
			case ($retval == false) :
				$_SESSION["tmp"]["msg"]["content"] = $string["error14"];
			break;
		}

	break;

	default :
		$Auth = new Authentication;
		$Auth->logout();
		exit;
}

$url = sprintf("Location: %s/mail.php?mode=user_list",
	$_SESSION["user_global_url"]);

$Site->DB->retval = $retval;
$Site->DB->close();

if ($retval) {
	$Site->end1();
	Header($url);
	exit;
} else {
	$Site->end1();

	goprev();
}

/*
Description
-----------

Author
------
 Spike^ekipS <spike@spikeekips.net>

Changelog
---------

Usage
-----

*/

?>
