// I18N constants

// LANG: "ko", ENCODING: EUC-KR
// Author: Spike^ekipS, <spike@spikeekips.net>

// FOR TRANSLATORS:
//
//   1. PLEASE PUT YOUR CONTACT INFO IN THE ABOVE LINE
//      (at least a valid email address)
//
//   2. PLEASE TRY TO USE UTF-8 FOR ENCODING;
//      (if this is not possible, please include a comment
//       that states what encoding is necessary.)

HTMLArea.I18N = {

	// the following should be the filename without .js extension
	// it will be used for automatically load plugin language.
	lang: "en",

	tooltips: {
		bold:           "ϰ ",
		italic:         "̱",
		underline:      " ߱",
		strikethrough:  "Ҽ ߱",
		subscript:      "Ʒ÷",
		superscript:    "÷",
		justifyleft:    " ",
		justifycenter:  " ",
		justifyright:   " ",
		justifyfull:    " ",
		orderedlist:    " ִ Ʈ",
		unorderedlist:  "׶ Ʈ",
		outdent:        "鿩 ̱",
		indent:         "鿩 ̱",
		forecolor:      "ڻ",
		hilitecolor:    "",
		horizontalrule: "μ",
		createlink:     "ũ ֱ",
		insertimage:    "̹ ֱ",
		inserttable:    "̺ ֱ",
		htmlmode:       "HTML ҽ /",
		popupeditor:    "â ̱",
		about:          " ʹ..",
		showhelp:       "",
		textindicator:  " Ÿ",
		undo:           " ",
		redo:           " ݺ",
		cut:            "߶󳻱",
		copy:           "",
		paste:          "ٿֱ"
	},

	buttons: {
		"ok":           "Ȯ",
		"cancel":       ""
	},

	msg: {
		"Path":         "ġ",
		"TEXT_MODE":    " ؽƮ忡 ֽϴ..  [<>] ư   ư  ֽϴ."
	}
};
