<?

include_once $global["root"] . "/lib/Page.php";
include_once $global["root"] . "/lib/Extend_Quota.php";
include_once $global["root"] . "/lib/Domain.php";
include_once $global["root"] . "/lib/User.php";
include_once $global["root"] . "/lib/Directories.php";
include_once $global["root"] . "/include/print_byte.php";
include_once $global["root"] . "/include/print_time.php";
include_once $global["root"] . "/lib/Extend_message.php";

class Domains {

	var $info;
	var $total_user_number = "0";

	var $Template;

	var $SQL_GET_USER_ALIAS_IN_DOMAIN =
		"select SQL_CACHE no, name, valid, user_no from user_alias_priv
			where domain = '%s' limit %s, %s";
	var $SQL_GET_USER_IN_DOMAIN =
		"select SQL_CACHE no, name, id, valid from user_priv
			where domain = '%s' limit %s, %s";
	var $SQL_GET_USER_INFO = "select SQL_CACHE * from user_priv where no = '%s'";
	var $SQL_GET_DOMAIN = "select no, name, valid from domain_priv";
	var $SQL_GET_DOMAIN_ALIAS =
		"select no, name, valid, domain_id from domain_alias_priv";

	function Domains () {

		// get domain info
		$DM = new Domain;
		$this->info = $DM->get_info();

		$this->Template = new Template;

	}

	function __return_domain_info ($no="") {
		global $global;

		$Domain = new Domain;

		if ($no) {
			$o = $Domain->get_info_by_no($no);
		} else {
			$o = $Domain->get_info();
		}

		//---------- unmutable item.
		$one["name"] = $o["name"];
		$one["quota"] = intval($o["quota"] / 1000000);
		$one["lang"] = $o["lang"];
		$one["message_size_limit"] = intval($o["message_size_limit"] / 1000000);
		$one["document_size_limit"] = intval($o["document_size_limit"] / 1000000);
		$one["filter"] = $o["filter"];
		$one["fake_address_limit"] = $o["fake_address_limit"];
		$one["user_limit"] = $o["user_limit"];
		$one["block_address"] = $o["block_address"];
		$one["remote_server"] = $o["remote_server"];
		$one["created_time"] = print_time($o["createdTime"], $_SESSION["config_lang"], true);

		//---------- mutable variable
		$fp = fopen($global["theme_config_file"], "r");
		if ($fp) {
			if ($o["theme"] == "") {
				$theme = "default";
			} else {
				$theme = $o["theme"];
			}

			while ($b = fgets($fp)) {
				if (ereg("^#", $b)) continue;

				$d = explode(" ", trim($b));

				if ($d[1] == $theme) {
					$k[] = sprintf("<option value=\"%s\" selected>%s", $d[1], $d[0]);
				} else {
					$k[] = sprintf("<option value=\"%s\">%s", $d[1], $d[0]);
				}

				$one["theme"] =
					sprintf("<select size=\"%s\" name=\"theme\">%s</select>",
						count($k) + 1 , implode("\n", $k));
			}
			fclose($fp);
			unset($k);
		} else {
			$one["theme"] = $_SESSION["config_theme"];
		}

		$fp = fopen($global["language_config_file"], "r");
		if ($fp) {
			if ($o["lang"] == "") {
				$lang = $global["default_language"];
			} else {
				$lang = $o["lang"];
			}

			while ($b = fgets($fp)) {
				if (ereg("^#", $b)) continue;

				$d = explode(" ", trim($b));

				if ($d[1] == $lang) {
					$k[] = sprintf("<option value=\"%s\" selected>%s", $d[1], $d[0]);
				} else {
					$k[] = sprintf("<option value=\"%s\">%s", $d[1], $d[0]);
				}

				$one["lang"] =
					sprintf("<select size=\"%s\" name=\"lang\">%s</select>",
						count($k) + 1 , implode("\n", $k));
			}
			fclose($fp);
			unset($k);
		} else {
			$one["lang"] = $_SESSION["config_lang"];
		}

		// domain alias
		if ($no) {
			$o = $Domain->get_alias($Domain->get_id_by_no($no));
		} else {
			$o = $Domain->get_alias();
		}

		if (count($o) < 1) {
			$one["domain_alias"] = "";
		} else {
			$one["domain_alias"] = $o;
		}

		return $one;
	}

	function return_domain_configuration () {

		$one = $this->__return_domain_info();

		if (is_array($one["domain_alias"]) and count($one["domain_alias"]) > 0) {
			$one["domain_alias"] = implode("<br>", $one["domain_alias"]);
		}

		$retval = $this->Template->generate("global/domain/domain_info", $one);

		return $retval;
	}

	// return user list.
	function return_user_alias_list ($pg=0) {
		global $global, $string;

		$DB = new MySQLdb;

		$Page = new Page_user_alias($pg, $_SESSION["config_domain"]);
		$main["page_list"] = $Page->print_list();

		$DB->query(
			sprintf($this->SQL_GET_USER_ALIAS_IN_DOMAIN,
				$_SESSION["config_domain"],
				$pg * $global["pagelimit"], $global["pagelimit"]),
			true);

		$User = new User;
		for ($i = 0; $i < $DB->num_rows; $i++) {
			unset($a);

			$o = $DB->fetch();
			$a["username"]= $o["name"];
			$a["no"]= $o["no"];

			$User->get_info_by_no($o["user_no"]);
			$a["real_name"]= $User->info["name"];
			$a["user_no"]= $User->info["no"];

			if ($o["valid"] == "1") {
				$a["is_valid"] = "selected";
			} else {
				$a["not_valid"] = "selected";
			}

			$main["content"] .=
				$this->Template->generate("global/domain/user_alias_list_one", $a);
		}

		$this->total_user_number += $DB->num_rows;

		$retval =
			$this->Template->generate("global/domain/user_alias_list", $main);

		return $retval;
	}

	function return_user_list ($pg=0, $pg_alias=0) {
		global $global, $string;

		$DB = new MySQLdb;
		$Page = new Page_user($pg, $_SESSION["config_domain"]);
		$main["page_list"] = $Page->print_list();

		$DB->query(
			sprintf($this->SQL_GET_USER_IN_DOMAIN,
				$_SESSION["config_domain"],
				$pg * $global["pagelimit"], $global["pagelimit"]),
			true);

		for ($i = 0; $i < $DB->num_rows; $i++) {
			unset($a);

			$o = $DB->fetch();
			$a["username"]= $o["name"];
			$a["user_no"]= $o["no"];
			$a["user_id"]= $o["id"];

			if ($o["valid"] == "1") {
				$a["is_valid"] = "selected";
			} else {
				$a["not_valid"] = "selected";
			}

			if ($a["username"] == $global["postmaster"]) {
				$template = "global/domain/user_list_one_postmaster";
			} else {
				$template = "global/domain/user_list_one";
			}

			$main["content"] .=
				$this->Template->generate($template, $a);
		}

		$this->total_user_number += $DB->num_rows;

		$main["user_limit"] = sprintf($string["admin24"],
			$this->info["user_limit"]);

		// user alias list.
		$main["alias_user_list"] = $this->return_user_alias_list($pg_alias);

		if ($this->info["user_limit"] > $this->total_user_number) {
			$main["create_user_form"] =
				$this->Template->generate(
					"global/domain/user_list_create_user_form");
		}

		$retval =
			$this->Template->generate("global/domain/user_list", $main);

		return $retval;
	}

	function return_user_info ($user_no) {
		global $global, $string;

		$DB = new MySQLdb;

		$DB->query(sprintf($this->SQL_GET_USER_INFO, $user_no), true);

		$o = $DB->fetch();

		$main["user_address"] = sprintf("%s@%s", $o["name"], $o["domain"]);
		$main["username"] = $o["name"];
		$main["user_id"] = $o["id"];
		$main["user_no"] = $o["no"];
		$main["domain_quota"] = print_byte(intval($this->info["quota"]));

		$main["password"] = $o["password_plain"];

		$main["quota"] = intval($o["quota"] / 1000000);

		$main["message_size_limit"] =
			intval($o["message_size_limit"] / 1000000);
		$main["document_size_limit"] =
			intval($o["document_size_limit"] / 1000000);

		$main["domain_message_size_limit"] =
			print_byte(intval($o["message_size_limit"]));
		$main["domain_document_size_limit"] =
			print_byte(intval($o["document_size_limit"]));

		// block address
		$main["block_address"] = $o["block_address"];
		$main["msg_block_address"] = sprintf($string["admin44"],
			$_SESSION["config_block_address"]);

		// remote_server
		$main["remote_server"] = $o["remote_server"];
		$main["msg_remote_server"] = sprintf($string["admin44"],
			$_SESSION["config_remote_server"]);

		// filter
		$main["filter"] = $o["filter"];
		$main["msg_filter"] =
			sprintf($string["admin44"], $_SESSION["config_filter"]);

		// fake address
		$main["fake_address_limit"] = $o["fake_address_limit"];
		$main["msg_fake_address_limit"] =
			sprintf($string["admin44"], $_SESSION["config_fake_address_limit"]);

		// quota policy.
		$Quota = new Extend_Quota;
		$main["quota_policy"] =
			$Quota->return_policy_select_form($o["id"], $o["quota_policy"]);

		if ($main["username"] != $global["postmaster"]) {
			$template = "global/domain/user_info";
		} else {
			$template = "global/domain/user_info_postmaster";
		}

		$retval = $this->Template->generate($template, $main);

		return $retval;
	}

	function return_filter () {
		global $global;

		$Control = new Control_Message;

		if ($_GET["code_no"] == "new") {
			$retval = $Control->add_filter();
		} else if ($_GET["code_no"]) {
			$retval = $Control->filter_item_one($_GET["code_no"]);
		} else if (! $_GET["code_no"]) {
			$retval = $Control->filter();
		}

		return $retval;
	}

	function return_block_address () {
		global $string;

		$Control = new Control_Message;
		$retval = $Control->return_block_address();

		return $retval;

	}

	//-------------------- for admin.
	function return_list () {
		$DB = new MySQLdb;

		$DB->fetch_query($this->SQL_GET_DOMAIN, true);

		for ($i = 0; $i < $DB->num_rows; $i++) {
			$o = $DB->fetch();

			$one["no"] = $o["no"];

			// valid or not.
			if (! $o["valid"]) $one["hold"] = "checked";

			// name
			if (! $o["valid"]) {
				$one["name"] =
					sprintf("<a class=\"mesian_read\"
						href=\"%s/global.php?mode=domain&no=%s\">%s</a>",
					$_SESSION["user_global_url"], $o["no"], $o["name"]);
			} else {
				$one["name"] =
					sprintf("<a class=\"mesian\"
						href=\"%s/global.php?mode=domain&no=%s\">%s</a>",
					$_SESSION["user_global_url"], $o["no"], $o["name"]);
			}

			$main["domain_list"] .=
				$this->Template->generate("global/global/domain_list_one", $one);

			unset($one);
		}

		$main["domain_alias_list"] = $this->return_alias_list();

		$retval = $this->Template->generate("global/global/domain_list", $main);
		return $retval;
	}

	function return_alias_list () {
		$DB = new MySQLdb;
		$Domain = new Domain;

		$DB->fetch_query($this->SQL_GET_DOMAIN_ALIAS, true);

		for ($i = 0; $i < $DB->num_rows; $i++) {
			$o = $DB->fetch();

			$one["no"] = $o["no"];
			$one["name"] = $o["name"];

			$var = $Domain->get_info_by_id($o["domain_id"]);
			if (! $var["name"]) {
				continue;
			} else {
				$one["real_name"] = $var["name"];
				$one["domain_no"] = $var["no"];
			}

			// valid or not.
			if (! $o["valid"]) {
				$one["invalid"] = "selected";
			} else {
				$one["valid"] = "selected";
			}

			$main["content"] .=
				$this->Template->generate("global/global/domain_alias_list_one", $one);

			unset($one);
		}

		$retval = $this->Template->generate("global/global/domain_alias_list", $main);
		return $retval;
	}

	function return_domain_info ($no) {

		$one = $this->__return_domain_info($no);
		$one["no"] = $no;
		if (is_array($one["domain_alias"])) $one["domain_alias"] = implode("<br>", $one["domain_alias"]);

		$retval = $this->Template->generate("global/global/domain_info", $one);

		return $retval;
	}

	function return_mail_configuration () {
		global $string;

		// get domain info.
		$Domain = new Domain;
		$info = $Domain->get_info_by_id($_SESSION["config_domain_id"]);

		// orphan message policy
		$a = $string["control47"]["orphan_message_policy"];
		while (list($i, $j) = each($a)) {

			if ($info["orphan_message_policy"] == $i) {
				$main["orphan_message_policy"] .=
					sprintf("<option value=\"%s\" selected> %s",
						$i, $j
					);
			} else {
				$main["orphan_message_policy"] .=
					sprintf("<option value=\"%s\"> %s",
						$i, $j
					);
			}
		}

		$main["orphan_message_duration_time"] = $info["orphan_message_duration_time"];

		$retval = $this->Template->generate("global/domain/mail_configuration", $main);

		return $retval;
	}
}

/*
Description
-----------

Author
------
 Spike^ekipS <spike@spikeekips.net>

Changelog
---------

Usage
-----

*/

?>
