<?

include_once $global["root"] . "/include/print_time.php";

include_once $global["root"] . "/lib/Page.php";
include_once $global["root"] . "/include/group.php";
include_once $global["root"] . "/lib/Doc_Group.php";
include_once $global["root"] . "/lib/Module_doc.php";
include_once $global["root"] . "/lib/Item.php";

class Extend_doc {

/*
	mysql> desc doc_1062803962;
	+------------+---------------+------+-----+------------+----------------+
	| Field      | Type          | Null | Key | Default    | Extra          |
	+------------+---------------+------+-----+------------+----------------+
	| no         | int(11)       |      | PRI | NULL       | auto_increment |
	| realname   | tinytext      | YES  |     | NULL       |                |
	| storedname | tinytext      |      |     |            |                |
	| size       | int(11)       |      |     | 0          |                |
	| mime_type  | tinytext      | YES  |     | NULL       |                |
	| author     | tinytext      | YES  |     | NULL       |                |
	| date       | varchar(10)   |      |     | 0000000000 |                |
	| comment    | longtext      | YES  |     | NULL       |                |
	| title      | tinytext      | YES  |     | NULL       |                |
	| flag       | enum('0','1') |      |     | 0          |                |
	+------------+---------------+------+-----+------------+----------------+
	10 rows in set (0.00 sec)
*/

	var $Template;
	var $Doc;
	var $Item;
	var $Group;

	var $empty = false;
	var $sort_key_list = array("title", "author", "document");

	var $SQL_GET_DOC_GROUP = 
		"select SQL_CACHE no,name from doc_group_%s";
	var $SQL_GET_DOC_ITEM_ALL = 
		"select SQL_CACHE item from doc_group_%s";
	var $SQL_GET_DOC_ITEM = 
		"select SQL_CACHE item from doc_group_%s where no = '%s'";
	var $SQL_GET_ALL_DOC = "select SQL_CACHE no from doc_%s";

	var $SQL_GET_DOC =
			"select SQL_CACHE
				no, realname, storedname, size, mime_type, author, date, comment, title
				from doc_%s where no = '%s'";

	function Extend_doc ($group_no="", $tihs_page="", $sort_key="") {

		$this->set_params($group_no, $tihs_page, $sort_key);

		// set module.
		$this->Template = new Template;
		$this->Doc = new Module_doc;
		$this->Item = new Item;
	}

	function set_params ($group_no="", $sort_key="", $this_page="") {
		global $global, $string;

		// assign parameters.

		if ($this_page) {
			$this->this_page = $this_page;
		} else if ($_SESSION["user_doc_page_number"]) {
			$this->this_page = $_SESSION["user_doc_page_number"];
		} else {
			$this->this_page = "0";
		}

		// set group number.
		if ($group_no) {
			$this->group_no = $group_no;
		} else if ($_SESSION["user_doc_group_no"]) {
			$this->group_no = $_SESSION["user_doc_group_no"];
		}

		$Group = new Doc_Group;
		$this->group_name = $Group->get_name($this->group_no);

		if ($sort_key) {
			$this->sort_key = $sort_key;
		} else if (array_key_exists("user_doc_group_sort_state", $_SESSION)) {
			if (array_key_exists($this->group_no, $_SESSION["user_doc_group_sort_state"])) {
				$this->sort_key = $_SESSION["user_doc_group_sort_state"][$this->group_no];
			} else {
				$this->sort_key = "title";
			}
		} else {
			$this->sort_key = "title";
		}

	}

	function get_items () {
		/*
		return the items as array.
		*/

		$DB = new MySQLdb;

		if ($this->group_no == "a") {

			// get list from doc_group
			$DB->query(sprintf($this->SQL_GET_DOC_ITEM_ALL, $_SESSION["config_id"]), true);

			for ($i = 0; $i < $DB->num_rows; $i++) {
				$o = $DB->fetch();
				$a = sprintf("%s,%s", $a, $o["item"]);
			}

			// get list from doc table.
			$Item = new Item;
			$l = $Item->get_in_trash($_SESSION["user_item_type_rv"]["doc"]);

			$DB->query(sprintf($this->SQL_GET_ALL_DOC, $_SESSION["config_id"]), true);

			for ($i = 0; $i < $DB->num_rows; $i++) {
				$o = $DB->fetch();
				if (in_array($o["no"], $l)) continue;
				$a = sprintf("%s,%s", $a, $o["no"]);
			}

			$retval = __return_array_for_group_item($a);

		} else if ($this->group_no == "trash") {
			$Item = new Item;
			$l = $Item->get_in_trash($_SESSION["user_item_type_rv"]["doc"]);

			$retval = $l;

		} else if ($this->group_no) {
			$o = $DB->fetch_one(
				sprintf($this->SQL_GET_DOC_ITEM,
					$_SESSION["config_id"], $this->group_no)
			);

			if (! $o["item"]) {
				$retval = false;
			} else {
				$retval = __return_array_for_group_item($o["item"]);
			}
		}

		return $retval;
	}

	function get_list ($items) {

		while (list($i, $j) = each($items)) {

			// make list line.
			$item_no = $this->Item->get_no($j, $_SESSION["user_item_type_rv"]["doc"]);
			$o = $this->Doc->info($j);

			if (! $o["title1"]) continue;

			$var["item_no"][$j] = $item_no;

			$var["no"][$j] = $j;
			$var["group_no"][$j] = $this->group_no;
			$var["title"][$j] = $o["title1"];
			$var["author"][$j] = $o["author"]["short"];
			$var["document"][$j] = $o["realname"];
			$var["createdTime"][$j] = print_time($o["createdTime"], $_SESSION["config_lang"]);
		}

		return $var;
	}

	function sort_list ($list) {

		if (array_key_exists("user_doc_group_sort_state_key", $_SESSION)) {
			if (! array_key_exists($this->group_no,
					$_SESSION["user_doc_group_sort_state_key"])) {
				asort($list[$this->sort_key]);
			} else {
				if ($_SESSION["user_doc_group_sort_state_key"][$this->group_no] == "r") {
					arsort($list[$this->sort_key]);
				} else if
						($_SESSION["user_doc_group_sort_state_key"][$this->group_no] == "o") {
					asort($list[$this->sort_key]);
				} else {
					arsort($list[$this->sort_key]); // default key is createdTime.
				}
			}

			reset($list[$this->sort_key]);
		}

		return $list;
	}

	function get_normal_list ($group_no="", $sort_key="", $this_page="") {
		$DB = new MySQLdb;

		$this->set_params($group_no, $sort_key, $this_page);

		// get all item.
		$all_items = $this->get_items();

		$main["group_no"] = $this->group_no;

		// handling sort key.
		$a = $this->sort_key_list;
		while (list($i, $j) = each($a)) {
			if ($this->sort_key == $j) {
				if ($_SESSION["user_doc_group_sort_state_key"][$this->group_no] ==
						"o") {
					$icon = "item/image/sort_descending-25.png";
				} else if ($_SESSION["user_doc_group_sort_state_key"][$this->group_no]
						== "r") {
					$icon = "item/image/sort_ascending-25.png";
				} else { // sort by createdTime
					$icon = "item/image/sort_default-25.png";
				}
			} else {
				$icon = "item/image/sort_default-25.png";
			}

			$main["label_sort_key_" . $j] =
				sprintf("%s/%s", $_SESSION["user_theme_url"], $icon);
		}

		if (! $all_items) { // no item in here.
			$this->empty = true;

			$main["content"] = $this->Template->generate("doc/doc_list_empty");
		} else {
			// set page numbering.
			$this->Page =
				new Page_doc($this->group_no, count($all_items), $this->this_page);

			$this->this_page = $this->Page->page_current;

			// get list in current page.
			while (list($i, $j) = each($all_items)) {
				if (
						$i < ($this->this_page * $_SESSION["config_pageLimit"]) or
						$i >= (($this->this_page + 1) * $_SESSION["config_pageLimit"])
					) continue;

				$current_list[] = $j;
			}

			$current_list = $this->get_list($current_list);

			$list = $this->sort_list($current_list);

			if (is_array($list[$this->sort_key])) {
				while (list($i, $j) = each($list[$this->sort_key])) {

					unset($one);

					$one["group_no"] = $this->group_no;
					$one["no"] = $list["no"][$i];
					$one["title"] = $list["title"][$i];
					$one["document"] =
						sprintf("<a class=\"mesian\"
							href=\"%s/action/doc/download.php?no=%s\">%s</a>",
							$_SESSION["user_global_url"], $one["no"], $list["document"][$i]
						);

					$main["content"] .=
						$this->Template->generate("doc/doc_list_one", $one);
				}
			}

			//-------------------- doc list label sorting key icon
		}

		$retval = $this->Template->generate("doc/doc_list",$main);

		return $retval;
	}

	function return_list ($group_no="", $sort_key="", $this_page="") {

		// get core list.
		$main["content"] = $this->get_normal_list($group_no, $sort_key, $this_page);
		$main["group_no"] = $this->group_no;

		// check item validity of group.
		if ($this->group_no != "a") {
			$Doc_Group = new Doc_Group($this->group_no);
			$Doc_Group->check_group_item_valid();
		}

		// etc
		$main["group_name"] = $this->group_name;

		// item list menu
		if ($this->group_no == "a") {
			$tmpl_suffix = "_group_all";
		} else if ($this->group_no == "trash") {
			$tmpl_suffix = "_trash";
		}

		if ($this->empty) {
			$item_list_menu_template =
				sprintf("doc/action_menu_not_active%s", $tmpl_suffix);
		} else {
			$item_list_menu_template =
				sprintf("doc/action_menu%s", $tmpl_suffix);
		}

		// item list sub-menu
		if ($this->empty) {
			$item_list_menu_sub_template =
				sprintf("doc/action_menu_sub_not_active%s", $tmpl_suffix);
		} else {
			$item_list_menu_sub_template =
				sprintf("doc/action_menu_sub%s", $tmpl_suffix);
			$item_list_menu_sub2_template =
				sprintf("doc/action_menu_sub2%s", $tmpl_suffix);
		}

		$main["item_list_menu"] = $this->Template->generate($item_list_menu_template);
		$main["item_list_menu_sub"] =
			$this->Template->generate($item_list_menu_sub_template);
		$main["item_list_menu_sub2"] =
			$this->Template->generate($item_list_menu_sub2_template);

		// page numbering
		if (! $this->empty) {
			// print page list.
			if ($this->Page->doc_total_num > $_SESSION["config_pageLimit"]) {
				$main["page_list"] = $this->Page->print_list();
			}
		}

		$retval = $this->Template->generate("doc/list", $main);

		return $retval;
	}

	// return left side menu.
	function return_menu () {
		$DB = new MySQLdb;

		$DB->query(sprintf($this->SQL_GET_DOC_GROUP, $_SESSION["config_id"]), true);

		for ($i = 0; $i < $DB->num_rows; $i++) {
			$o = $DB->fetch();

			unset($var);
			$var["name"] = $o["name"];
			$var["group_no"] = $o["no"];

			$group["content"] .= $this->Template->generate(
					"doc/doc_menu_group_list_one",
					$var
				);
		}

		$main["group"] = $this->Template->generate(
				"doc/doc_menu_group_list", $group);
		$main["module"] = $this->Template->generate(
				"doc/doc_menu_module");

		$retval = $this->Template->generate( "doc/doc_menu", $main);

		return $retval;
	}

	function view ($no, $group_no="") {

		// set group number.
		if ($group_no == "a") {
			$this->group_no = "a";
		} else if ($group_no) {
			$this->group_no = $group_no;
		} else if ($_SESSION["user_doc_group_no"]) {
			$this->group_no = $_SESSION["user_doc_group_no"];
		}

		$item_no = $this->Item->get_no($no, $_SESSION["user_item_type_rv"]["doc"]);
		$o = $this->Doc->view($no, $item_no);

		return $o;
	}

}

/*
Description
-----------

Author
------
 Spike^ekipS <spike@spikeekips.net>

Changelog
---------

Usage
-----

*/

?>
