<?

include_once $global["root"] . "/include/print_time.php";

include_once $global["root"] . "/lib/Basic_doc.php";
include_once $global["root"] . "/lib/Address.php";

class Module_Doc extends Basic_doc {

	var $Template;
	var $SQL_GET_DOC = "select SQL_CACHE
				realname, storedname, size, mime_type, author, date, comment, title, flag
				from doc_%s where no = '%s'";
	var $SQL_CHECK_FLAG = "update doc_%s set flag = '1' where no = '%s'";

	function print_view ($no) {
		global $global, $string;

		$DB = new MySQLdb;

		$o = $DB->fetch_one(sprintf($this->SQL_GET_DOC, $_SESSION["config_id"], $no));

		$main["title"] = $o["title"];
		$main["comment"] = wordwrap(htmlspecialchars($o["comment"]), 90, "\n");

		$Address = new Address($o["author"]);
		$c = $Address->return_split();

		$main["author"] =
			sprintf("%s &lt; %s &gt;", $c["short"], $c["full"]);
		$main["no"] = $no;
		$main["file"] = $o["realname"];

		$main["date"] = print_time($o["date"], $_SESSION["config_lang"], true);

		$retval =
			$this->Template->generate("doc/print_view", $main);

		return $retval;
	}

	function view ($no, $item_num) {
		global $global, $string;

		$DB = new MySQLdb;

		$o = $DB->fetch_one(sprintf($this->SQL_GET_DOC, $_SESSION["config_id"], $no));

		$main["title"] = $o["title"];
		$main["comment"] = wordwrap(htmlspecialchars($o["comment"]), 90, "\n");

		$main["author"] =
			sprintf("<a class=\"mesian\"
				href=\"%s/mail.php?mode=add&no=1&address=%s\">%s &lt; %s &gt;</a>",
				$_SESSION["user_global_url"], $o["email"], $o["author"], $o["email"]);
		$main["no"] = $no;
		$main["file"] = $o["realname"];

		$main["date"] = print_time($o["date"], $_SESSION["config_lang"], true);

		if ($_GET["mode"] == "search_view") {
			// highlighting string.
			$new_string = sprintf("<span class=\"mesian_highlighting\">%s</span>",
				$_SESSION["user_search_string"]);
			$main["title"] = str_replace($_SESSION["user_search_string"],
				$new_string, $main["title"]);
			$main["comment"] = str_replace($_SESSION["user_search_string"],
				$new_string, $main["comment"]);
			$main["file"] = str_replace($_SESSION["user_search_string"],
				$new_string, $main["file"]);

			$main["arg_gotolist"] = $_SESSION["user_query_search"];
		} else {
			$main["arg_gotolist"] = sprintf("mode=list&no=%s&pg=%s",
				$_SESSION["user_directory"], $_SESSION["user_page_number"]);
		}

		$main["item_num"] = $item_num;

		$retval = $this->Template->generate("doc/view", $main);

		if ($o["flag"] != "1") {
			$DB->query(sprintf($this->SQL_CHECK_FLAG, $_SESSION["config_id"], $no));
		}

		return $retval;
	}

}

/*
Description
-----------

Author
------
 Spike^ekipS <spike@spikeekips.net>

Changelog
---------

Usage
-----

*/

?>
