<?

class Page {

	var $page_total;
	var $page_current;
	var $directory;

	var $number_of_page_nums = 14;

	var $item_total_num;

	var $DB;

	var $SQL_GET_TOTAL_ITEM =
		"select SQL_CACHE count(no) as num from item_%s where directory_num = '%s'";

	function Page ($directory, $page_current="") {
		$this->Template = new Template;

		$this->DB = new MySQLdb;

		$this->directory = $directory;
		$this->get_page_total();

		if ($page_current) $this->set($page_current);
	}

	function set ($page_current) {

		if ($page_current < 0) {
			$this->page_current = "0";
		} else {
			$this->page_current = $page_current;

			if ($this->page_current >= $this->page_total) {
				$this->page_current = $this->page_total - 1;
			}
		}
	}

	function get_page_total () {

		$o = $this->DB->fetch_one(sprintf($this->SQL_GET_TOTAL_ITEM,
			$_SESSION["config_id"], $this->directory));

		$this->item_total_num = $o["num"];

		if ($o["num"] < $_SESSION["config_pageLimit"]) {
			$this->page_total = "1";
		} else {
			$a = intval($o["num"] / $_SESSION["config_pageLimit"]);
			$b = intval($o["num"] % $_SESSION["config_pageLimit"]);

			if ($b == "0") {
				$this->page_total = $a;
			} else {
				$this->page_total = $a + 1;
			}
		}
	}

	function print_list ($page_current="") {
		global $global, $string;

		if ($page_current) $this->set($page_current);

		// page numbering.
		if ($this->page_total > 1) {

			$tail_page_start = "";
			$tail_page_end = "";

			if ($this->page_total > $this->number_of_page_nums) {
				$page_start = $this->page_current - round($this->number_of_page_nums / 2);
				$page_end = $this->page_current + round($this->number_of_page_nums / 2);

				$tail_page_start = "...";
				$tail_page_end = "...";

				// check the validity of page number.
				if ($page_start <= 0) {
					$page_start = 0;
					$page_end = $page_start + round($this->number_of_page_nums / 2) + 1;
					$tail_page_start = "";
				}
				if ($page_end > $this->page_total) {
					$page_end = $page_end = $this->page_total;
					$tail_page_end = "";
				}

			} else {
				$page_start = 0;
				$page_end = $this->page_total;
			}

			for ($i = $page_start; $i < $page_end; $i++) {
				$one["num"] = $i;

				if ($i == $this->page_current) {
					$one["page_num"] =
						sprintf("<span class=\"mesian_label2\">%s</span>", $i + 1);
				} else {
					$one["page_num"] =
						sprintf("<a class=\"mesian\"
							href=\"%s/mail.php?mode=list&no=%s&pg=%s\">%s</a>",
							$_SESSION["user_global_url"], $_SESSION["user_directory"],$i, $i + 1);
				}

				$page_list .=
					$this->Template->generate("item/page_list_one", $one);
			}

			$main["content"] =
				sprintf("%s %s %s", $tail_page_start, $page_list, $tail_page_end);
		}

		$prv = $this->page_current - 1;
		$fwd = $this->page_current + 1;

		if ($prv < 0) $prv = "0";
		if ($fwd > $this->page_total) $fwd = $this->page_total;

		if ($this->page_current < 1) {
			$main["prv"] = $this->Template->generate("global/page_previous_not_active");
		} else {
			$a["directory"] = $_SESSION["user_directory"];
			$a["pg_no"] = $prv;
			$main["prv"] = $this->Template->generate("global/page_previous", $a);
		}

		if ($fwd == $this->page_total) {
			$main["fwd"] = $this->Template->generate("global/page_forward_not_active");
		} else {
			$a["directory"] = $_SESSION["user_directory"];
			$a["pg_no"] = $fwd;

			$main["fwd"] = $this->Template->generate("global/page_forward", $a);
		}

		$ret = $this->Template->generate("item/page_list", $main);

		return $ret;
	}

}

class Page_card {

	var $page_total;
	var $page_current;

	var $group_no;
	var $card_total_num;

	var $DB;

	function Page_card ($group_no, $total_item_number="0", $page_current="") {
		$this->Template = new Template;

		$this->DB = new MySQLdb;

		$this->group_no = $group_no;
		$this->get_page_total($total_item_number);

		if ($page_current) $this->set($page_current);
	}

	function set ($page_current) {
		if ($page_current < 0) {
			$this->page_current = "0";
		} else {
			$this->page_current = $page_current;

			if ($this->page_current >= $this->page_total) {
				$this->page_current = $this->page_total - 1;
			}
		}
	}

	function get_page_total ($total_item_number="") {

		$this->card_total_num = $total_item_number;

		if ($this->card_total_num < $_SESSION["config_pageLimit"]) {
			$this->page_total = "1";
		} else {
			$a = intval($this->card_total_num / $_SESSION["config_pageLimit"]);
			$b = intval($this->card_total_num % $_SESSION["config_pageLimit"]);

			if ($b == "0") {
				$this->page_total = $a;
			} else {
				$this->page_total = $a + 1;
			}
		}
	}

	function print_list ($page_current="") {
		global $global, $string;

		if ($page_current) $this->set($page_current);

		// page numbering.
		if ($this->page_total > 1) {
			for ($i = 0; $i < $this->page_total; $i++) {
				$one["num"] = $i;

				if ($i == $this->page_current) {
					$one["page_num"] =
						sprintf("<span class=\"mesian_label2\">%s</span>", $i + 1);
				} else {
					$one["page_num"] =
						sprintf("<a class=\"mesian\"
							href=\"%s/mail.php?mode=card&no=%s&pg=%s\">%s</a>",
							$_SESSION["user_global_url"],
							$_SESSION["user_card_group_no"], $i, $i + 1);
				}

				$main["content"] .=
					$this->Template->generate("card/page_list_one", $one);
			}
		}

		$prv = $this->page_current - 1;
		$fwd = $this->page_current + 1;

		if ($prv < 0) $prv = "0";
		if ($fwd > $this->page_total) $fwd = $this->page_total;

		if ($this->page_current < 1) {
			$main["prv"] = $this->Template->generate("card/page_previous_not_active");
		} else {
			$a["directory"] = $this->group_no;
			$a["pg_no"] = $prv;
			$main["prv"] = $this->Template->generate("card/page_previous", $a);
		}

		if ($fwd == $this->page_total) {
			$main["fwd"] = $this->Template->generate("card/page_forward_not_active");
		} else {
			$a["directory"] = $this->group_no;
			$a["pg_no"] = $fwd;

			$main["fwd"] = $this->Template->generate("card/page_forward", $a);
		}

		$ret = $this->Template->generate("card/page_list", $main);

		return $ret;
	}

}

class Page_doc {

	var $page_total;
	var $page_current;

	var $group_no;
	var $doc_total_num;

	var $DB;

	function Page_doc ($group_no, $total_item_number="0", $page_current="") {
		$this->Template = new Template;

		$this->DB = new MySQLdb;

		$this->group_no = $group_no;
		$this->get_page_total($total_item_number);

		if ($page_current) $this->set($page_current);
	}

	function set ($page_current) {
		if ($page_current < 0) {
			$this->page_current = "0";
		} else {
			$this->page_current = $page_current;

			if ($this->page_current >= $this->page_total) {
				$this->page_current = $this->page_total - 1;
			}
		}
	}

	function get_page_total ($total_item_number="") {

		$this->doc_total_num = $total_item_number;

		if ($this->doc_total_num < $_SESSION["config_pageLimit"]) {
			$this->page_total = "1";
		} else {
			$a = intval($this->doc_total_num / $_SESSION["config_pageLimit"]);
			$b = intval($this->doc_total_num % $_SESSION["config_pageLimit"]);

			if ($b == "0") {
				$this->page_total = $a;
			} else {
				$this->page_total = $a + 1;
			}
		}
	}

	function print_list ($page_current="") {
		global $global, $string;

		if ($page_current) $this->set($page_current);

		// page numbering.
		if ($this->page_total > 1) {
			for ($i = 0; $i < $this->page_total; $i++) {
				$one["num"] = $i;

				if ($i == $this->page_current) {
					$one["page_num"] =
						sprintf("<span class=\"mesian_label2\">%s</span>", $i + 1);
				} else {
					$one["page_num"] =
						sprintf("<a class=\"mesian\"
							href=\"%s/mail.php?mode=doc&no=%s&pg=%s\">%s</a>",
							$_SESSION["user_global_url"],
							$_SESSION["user_doc_group_no"], $i, $i + 1);
				}

				$main["content"] .=
					$this->Template->generate("doc/page_list_one", $one);
			}
		}

		$prv = $this->page_current - 1;
		$fwd = $this->page_current + 1;

		if ($prv < 0) $prv = "0";
		if ($fwd > $this->page_total) $fwd = $this->page_total;

		if ($this->page_current < 1) {
			$main["prv"] = $this->Template->generate("doc/page_previous_not_active");
		} else {
			$a["directory"] = $this->group_no;
			$a["pg_no"] = $prv;
			$main["prv"] = $this->Template->generate("doc/page_previous", $a);
		}

		if ($fwd == $this->page_total) {
			$main["fwd"] = $this->Template->generate("doc/page_forward_not_active");
		} else {
			$a["directory"] = $this->group_no;
			$a["pg_no"] = $fwd;

			$main["fwd"] = $this->Template->generate("doc/page_forward", $a);
		}

		$ret = $this->Template->generate("doc/page_list", $main);

		return $ret;
	}

}

class Page_user {

	var $page_total;
	var $page_current;
	var $domain;

	var $item_total_num;

	var $DB;

	var $SQL_GET_TOTAL_USER =
		"select SQL_CACHE count(no) as num from user_priv where domain = '%s'";

	function Page_user ($page_current="", $domain) {
		$this->Template = new Template;

		$this->DB = new MySQLdb;

		$this->domain = $domain;
		$this->get_page_total();

		if ($page_current) $this->set($page_current);
	}

	function set ($page_current) {
		if ($page_current < 0) {
			$this->page_current = "0";
		} else {
			$this->page_current = $page_current;

			if ($this->page_current >= $this->page_total) {
				$this->page_current = $this->page_total - 1;
			}
		}
	}

	function get_page_total () {
		global $global;

		$o = $this->DB->fetch_one(sprintf($this->SQL_GET_TOTAL_USER, $this->domain));

		$this->item_total_num = $o["num"];

		if ($o["num"] < $global["pagelimit"]) {
			$this->page_total = "1";
		} else {
			$a = intval($o["num"] / $global["pagelimit"]);
			$b = intval($o["num"] % $global["pagelimit"]);

			if ($b == "0") {
				$this->page_total = $a;
			} else {
				$this->page_total = $a + 1;
			}
		}

	}

	function print_list ($page_current="") {
		global $global, $string;

		if ($page_current) $this->set($page_current);

		// page numbering.
		if ($this->page_total > 1) {
			for ($i = 0; $i < $this->page_total; $i++) {
				$one["num"] = $i;

				if ($i == $this->page_current) {
					$one["page_num"] =
						sprintf("<span class=\"mesian_label2\">%s</span>", $i + 1);
				} else {
					$one["page_num"] =
						sprintf("<a class=\"mesian\"
							href=\"%s/domain.php?mode=list&pg=%s\">%s</a>",
							$_SESSION["user_global_url"], $i, $i + 1);
				}

				$main["content"] .=
					$this->Template->generate("global/domain/page_list_one", $one);
			}
		}

		$prv = $this->page_current - 1;
		$fwd = $this->page_current + 1;

		if ($prv < 0) $prv = "0";
		if ($fwd > $this->page_total) $fwd = $this->page_total;

		if ($this->page_current < 1) {
			$main["prv"] = $this->Template->generate("global/domain/page_previous_not_active");
		} else {
			$a["pg_no"] = $prv;
			$main["prv"] = $this->Template->generate("global/domain/page_previous", $a);
		}

		if ($fwd == $this->page_total) {
			$main["fwd"] = $this->Template->generate("global/domain/page_forward_not_active");
		} else {
			$a["pg_no"] = $fwd;

			$main["fwd"] = $this->Template->generate("global/domain/page_forward", $a);
		}

		$ret = $this->Template->generate("global/domain/page_list", $main);

		return $ret;
	}

}

class Page_user_alias {

	var $page_total;
	var $page_current;
	var $domain;

	var $item_total_num;

	var $DB;

	var $SQL_GET_TOTAL_USER_ALIAS =
		"select SQL_CACHE count(no) as num from user_alias_priv where domain = '%s'";

	function Page_user_alias ($page_current="", $domain) {
		$this->Template = new Template;

		$this->DB = new MySQLdb;

		$this->domain = $domain;
		$this->get_page_total();

		if ($page_current) $this->set($page_current);
	}

	function set ($page_current) {
		if ($page_current < 0) {
			$this->page_current = "0";
		} else {
			$this->page_current = $page_current;

			if ($this->page_current >= $this->page_total) {
				$this->page_current = $this->page_total - 1;
			}
		}
	}

	function get_page_total () {
		global $global;

		$o = $this->DB->fetch_one(sprintf($this->SQL_GET_TOTAL_USER_ALIAS, $this->domain));

		$this->item_total_num = $o["num"];

		if ($o["num"] < $global["pagelimit"]) {
			$this->page_total = "1";
		} else {
			$a = intval($o["num"] / $global["pagelimit"]);
			$b = intval($o["num"] % $global["pagelimit"]);

			if ($b == "0") {
				$this->page_total = $a;
			} else {
				$this->page_total = $a + 1;
			}
		}

	}

	function print_list ($page_current="") {
		global $global, $string;

		if ($page_current) $this->set($page_current);

		// page numbering.
		if ($this->page_total > 1) {
			for ($i = 0; $i < $this->page_total; $i++) {
				$one["num"] = $i;

				if ($i == $this->page_current) {
					$one["page_num"] =
						sprintf("<span class=\"mesian_label2\">%s</span>", $i + 1);
				} else {
					$one["page_num"] =
						sprintf("<a class=\"mesian\"
							href=\"%s/domain.php?mode=list&pg_alias=%s\">%s</a>",
							$_SESSION["user_global_url"], $i, $i + 1);
				}

				$main["content"] .=
					$this->Template->generate("global/domain/page_list_one", $one);
			}
		}

		$prv = $this->page_current - 1;
		$fwd = $this->page_current + 1;

		if ($prv < 0) $prv = "0";
		if ($fwd > $this->page_total) $fwd = $this->page_total;

		if ($this->page_current < 1) {
			$main["prv"] = $this->Template->generate("global/domain/page_previous_not_active");
		} else {
			$a["pg_no"] = $prv;
			$main["prv"] = $this->Template->generate("global/domain/page_previous_alias", $a);
		}

		if ($fwd == $this->page_total) {
			$main["fwd"] = $this->Template->generate("global/domain/page_forward_not_active");
		} else {
			$a["pg_no"] = $fwd;

			$main["fwd"] = $this->Template->generate("global/domain/page_forward_alias", $a);
		}

		$ret = $this->Template->generate("global/domain/page_list", $main);

		return $ret;
	}

}

class Page_search {

	var $page_total;
	var $page_current;

	var $item_total_num;

	var $DB;

	function Page_search ($page_current="", $item_total_num) {

		$this->Template = new Template;
		$this->item_total_num = $item_total_num;
		$this->get_page_total();

		if ($page_current) $this->set($page_current);

	}

	function set ($page_current) {
		if ($page_current < 0) {
			$this->page_current = "0";
		} else {
			$this->page_current = $page_current;

			if ($this->page_current >= $this->page_total) {
				$this->page_current = $this->page_total - 1;
			}
		}
	}

	function get_page_total () {

		if ($this->item_total_num < $_SESSION["config_pageLimit"]) {
			$this->page_total = "1";
		} else {
			$a = intval($this->item_total_num / $_SESSION["config_pageLimit"]);
			$b = intval($this->item_total_num % $_SESSION["config_pageLimit"]);

			if ($b == "0") {
				$this->page_total = $a;
			} else {
				$this->page_total = $a + 1;
			}
		}
	}

	function print_list ($page_current="") {

		if ($page_current) $this->set($page_current);

		// page numbering.
		$add_query = ereg_replace("pg=[0-9][0-9]*\&", "", $_SERVER["QUERY_STRING"]);

		if ($this->page_total < 2) {
			$main["content"] = "<span class=\"mesian_bold\">1</span>";
		} else {
			for ($i = 0; $i < $this->page_total; $i++) {
				$one["num"] = $i;

				if ($i == $this->page_current) {
					$one["page_num"] =
						sprintf("<span class=\"mesian_label2\">%s</span>", $i + 1);
				} else {

					$one["page_num"] =
						sprintf("<a class=\"mesian\" href=\"%s/mail.php?pg=%s&%s\">%s</a>",
							$_SESSION["user_global_url"],
							$i,
							$add_query,
							$i + 1);
				}

				$main["content"] .=
					$this->Template->generate("item/page_list_one", $one);
			}
		}

		$prv = $this->page_current - 1;
		$fwd = $this->page_current + 1;

		if ($prv < 0) $prv = "0";
		if ($fwd > $this->page_total) $fwd = $this->page_total;

		if ($this->page_current < 1) {
			$main["prv"] = $this->Template->generate("global/page_previous_not_active");
		} else {
			$a["pg_no"] = $prv;
			$a["query"] = sprintf("pg=%s&%s", $prv, $add_query);
			$main["prv"] = $this->Template->generate("item/page_previous_search", $a);
		}

		if ($fwd == $this->page_total) {
			$main["fwd"] = $this->Template->generate("global/page_forward_not_active");
		} else {
			$a["query"] = sprintf("pg=%s&%s", $fwd, $add_query);
			$a["pg_no"] = $fwd;

			$main["fwd"] = $this->Template->generate("item/page_forward_search", $a);
		}

		$ret = $this->Template->generate("item/page_list", $main);

		return $ret;
	}

}

class Page_Domain_Message {

	var $page_total;
	var $page_current;

	var $item_total_num;

	var $DB;

	var $SQL_GET_TOTAL_ITEM =
		"select SQL_CACHE count(no) as num from mail_unKnown where address like '%s'";

	function Page_Domain_Message ($page_current="") {
		$this->Template = new Template;

		$this->DB = new MySQLdb;

		$this->get_page_total();

		if ($page_current) $this->set($page_current);
	}

	function set ($page_current) {
		if ($page_current < 0) {
			$this->page_current = "0";
		} else {
			$this->page_current = $page_current;

			if ($this->page_current >= $this->page_total) {
				$this->page_current = $this->page_total - 1;
			}
		}
	}

	function get_page_total () {

		$o = $this->DB->fetch_one(sprintf($this->SQL_GET_TOTAL_ITEM,
			"%@" . $_SESSION["config_domain"]));

		$this->item_total_num = $o["num"];

		if ($o["num"] < $_SESSION["config_pageLimit"]) {
			$this->page_total = "1";
		} else {
			$a = intval($o["num"] / $_SESSION["config_pageLimit"]);
			$b = intval($o["num"] % $_SESSION["config_pageLimit"]);

			if ($b == "0") {
				$this->page_total = $a;
			} else {
				$this->page_total = $a + 1;
			}
		}
	}

	function print_list ($page_current="") {
		global $global, $string;

		if ($page_current) $this->set($page_current);

		// page numbering.
		if ($this->page_total > 1) {
			for ($i = 0; $i < $this->page_total; $i++) {
				$one["num"] = $i;

				if ($i == $this->page_current) {
					$one["page_num"] =
						sprintf("<span class=\"mesian_label2\">%s</span>", $i + 1);
				} else {
					$one["page_num"] =
						sprintf("<a class=\"mesian\"
							href=\"%s/domain.php?mode=message_list&pg=%s\">%s</a>",
							$_SESSION["user_global_url"], $i, $i + 1);
				}

				$main["content"] .=
					$this->Template->generate("global/domain/page_message_list_one", $one);
			}
		}

		$prv = $this->page_current - 1;
		$fwd = $this->page_current + 1;

		if ($prv < 0) $prv = "0";
		if ($fwd > $this->page_total) $fwd = $this->page_total;

		if ($this->page_current < 1) {
			$main["prv"] =
				$this->Template->generate("global/domain/page_message_previous_not_active");
		} else {
			$a["pg_no"] = $prv;
			$main["prv"] =
				$this->Template->generate("global/domain/page_message_previous", $a);
		}

		if ($fwd == $this->page_total) {
			$main["fwd"] =
				$this->Template->generate("global/domain/page_message_forward_not_active");
		} else {
			$a["pg_no"] = $fwd;

			$main["fwd"] =
				$this->Template->generate("global/domain/page_message_forward", $a);
		}

		$ret = $this->Template->generate("global/domain/page_message_list", $main);

		return $ret;
	}

}

/*
Description
-----------

Author
------
 Spike^ekipS <spike@spikeekips.net>

Changelog
---------

Usage
-----

*/

?>
