# -*- coding: utf-8 -*-
import twisted.internet.reactor

import sys

import config, mySystem, template, myMySQLdb
import Imap4Server
#------------------------------------------------------------

if not config.default.has_key("imap_port") :
	print "IMAP server does not started."
	sys.exit(1)

DB = myMySQLdb.myMySQLdb()
DB.connect(config.db)

mySystem.fork_this(pid=template.file["pid"]["imap_server"])

factory = Imap4Server.Factory(DB)
factory.protocol = Imap4Server.Server

twisted.internet.reactor.listenTCP(config.default["imap_port"], factory)
twisted.internet.reactor.run()

"""
Description
-----------


ChangeLog
---------


Usage
-----


"""

__author__ =  "Spike^ekipS <spike@spikeekips.net>"
__version__=  "0.1"
__nonsense__ = ""

__file__ = "daemon.Imap4Server.py"

