<?
// Wriiten by Spike^ekipS <spike@spikeekips.net>

include_once "./setting.php";

include_once $global["root"] . "/include/handle.php";
include_once $global["root"] . "/include/print_array.php";
include_once $global["root"] . "/include/message/do.php";

include_once $global["root"] . "/lib/Site.php";
include_once $global["root"] . "/lib/Item.php";
include_once $global["root"] . "/lib/Basic_message.php";

$Site = new Site;
$Site->init();
$Site->set_permission("user");
include_once $global["lang"] . "/" . $_SESSION["config_lang"] . ".php";

$Quota = new Quota;
if (! $Quota->check_quota("send")) {
	$Site->end1();
	goprev();
}

$items = explode(",", $_POST["items"]);

if (count($items) < 1) {
	$Site->end1();
	goprev();
}

// get messsage info.
$retval = true;
$Item = new Item;
$Message = new Basic_message;

while (list($i, $j) = each($items)) {
	if (! $retval) break;

	// get no in mail_%s table.
	$Item->set($j);
	$info = $Item->info();

	if (! $info["author"]) continue;

	$var["message_id"] = $info["message_id"];
	$var["To"] = explode(",", $info["author"]["full"]);

	// get entireMessage
	$var["entireMessage"] = $Message->get_entireMessage($Item->item_num);

	// send it.
	$retval = send_mail_draft($var);

	if ($retval) $retval = $Item->remove(true);
}

if ($retval) {
	// payload test
	$Payload = new Payload;
	$Payload->clean();

	$url = sprintf(
		"Location: %s%s", $_SESSION["user_global_url"], $_SESSION["user_previous_page"]);

	$Site->end1();

	Header($url);
	exit;
} else {
	$Site->end1();
	goprev();
}

/*
Changelog
---------
Mon Mar  3 11:14:56 KST 2003
- retouched.

Mon Mar  3 11:15:04 KST 2003
- big file size(larger than 1047552) can not be inserted into queue table.
  It was caused  from the limitation of 'post_max_size', 'upload_max_filesize'
  (PHP) and 'max_allowed_packet' (MySQL).

  So set it high!
  -----------------
  post_max_size = 20M
  upload_max_filesize = 20M
  (Edit php.ini)

  max_allowed_packet = 200000000
  (mysql> set max_allowed_packet = 200000000;)

Wed Mar  5 17:55:43 KST 2003
- sendmailThruXMLRPC() added.

Mon Jul 21 03:09:22 KST 2003
- new authentication system applied.

*/

?>
