<?

include_once $global["root"] . "/lib/Authentication.php";
include_once $global["root"] . "/lib/Template.php";

class Authentication_Global extends Authentication {

	function assign () {
		global $global;

		$_SESSION["config_id"] = "global";
		$_SESSION["config_global"] = "global";
		$_SESSION["config_name"] = "global";
		$_SESSION["config_domain"] = $_SERVER["HTTP_HOST"];
		$_SESSION["config_lang"] = $global["default_language"];
		$_SESSION["config_timeout"] = 1800;
		$_SESSION["config_theme"] = $global["default_theme"];

		// it means unlimited.
		$_SESSION["config_filter"] = intval("-1");
		$_SESSION["config_block_address"] = intval("-1");

		// set timeout.
		$_SESSION["user_timeout"] = $_SESSION["config_timeout"] + mktime();

		$_SESSION["user_authenticated"] = true;
		$_SESSION["user_type"] = "global";

		$_SESSION["user_global_url"] = sprintf("http://%s", $_SERVER["HTTP_HOST"]);

		$_SESSION["user_theme_url"] =
			sprintf("http://%s/template/%s", $_SERVER["HTTP_HOST"], $_SESSION["config_theme"]);

		$Template = new Template;
		$Template->set_theme();

	}

}

/*
Description
-----------

Author
------
 Spike^ekipS <spike@spikeekips.net>

Changelog
---------

Usage
-----

*/

?>
