<?

class Domain {

	var $domain;
	var $info;

	// sql
	var $SQL_GET_DOMAIN_TYPE =
		"select SQL_CACHE DISTINCT valid, www_name from domain_priv
			where www_name = '%s'";
	var $SQL_GET_DOMAIN_ID =
		"select SQL_CACHE id from domain_priv where name = '%s'";
	var $SQL_GET_DOMAIN_ID_BY_NO =
		"select SQL_CACHE id from domain_priv where no = '%s'";
	var $SQL_GET_DOMAIN_ID_BY_WWW =
		"select SQL_CACHE id from domain_priv where www_name = '%s'";
	var $SQL_GET_DOMAIN_INFO =
		"select SQL_CACHE * from domain_priv where name = '%s'";
	var $SQL_GET_DOMAIN_INFO_BY_ID =
		"select SQL_CACHE * from domain_priv where id = '%s'";
	var $SQL_GET_DOMAIN_INFO_BY_NO =
		"select SQL_CACHE * from domain_priv where no = '%s'";
	var $SQL_GET_DOMAIN_INFO_BY_WWW_NAME =
		"select SQL_CACHE * from domain_priv where www_name = '%s'";
	var $SQL_GET_DOMAIN_ALIAS =
		"select SQL_CACHE * from domain_alias_priv where domain_id = '%s'";
	var $SQL_CHECK_VALID_DOMAIN =
		"select SQL_CACHE valid from domain_priv where name = '%s'";
	var $SQL_COUNT_DOMAIN_ALIAS =
		"select SQL_CACHE count(no) as num from domain_alias_priv
			where name = '%s' and domain_id = '%s'";

	var $ADMIN_NAME = "postmaster";

	function get_valid ($domain_name=false) {

		if ($domain_name) $this->domain = $domain_name;

		$DB = new MySQLdb;
		$o = $DB->fetch_one(sprintf($this->SQL_CHECK_VALID_DOMAIN, $this->domain));

		$retval = $o["valid"];

		return $retval;
	}

	function get_id ($domain_name) {

		$DB = new MySQLdb;
		$o = $DB->fetch_one(sprintf($this->SQL_GET_DOMAIN_ID, $domain_name));

		if ($o["id"]) {
			$retval = $o["id"];
		} else {
			$retval = false;
		}

		return $retval;
	}

	function get_id_by_no ($no) {

		$DB = new MySQLdb;
		$o = $DB->fetch_one(sprintf($this->SQL_GET_DOMAIN_ID_BY_NO, $no));

		if ($o["id"]) {
			$retval = $o["id"];
		} else {
			$retval = false;
		}

		return $retval;
	}

	function get_id_by_www ($www_name) {

		$DB = new MySQLdb;
		$o = $DB->fetch_one(sprintf($this->SQL_GET_DOMAIN_ID_BY_WWW, $www_name));

		if ($o["id"]) {
			$retval = $o["id"];
		} else {
			$retval = false;
		}

		return $retval;
	}

	function get_domain_type ($www_name="false") {

		if ($www_name) $this->domain = trim($www_name);

		$DB = new MySQLdb;

		$o = $DB->fetch_one(
			sprintf($this->SQL_GET_DOMAIN_TYPE, $this->domain, $this->domain));

		if ($o["www_name"] == $this->domain and $o["valid"]) {
			$retval = "www";
		} else {
			$retval = false;
		}

		return $retval;
	}

	function get_info ($domain_name=false) {
		$DB = new MySQLdb;

		if ($domain_name) {
			$this->domain = $domain_name;
		} else {
			$this->domain = $_SESSION["config_domain"];
		}

		$this->info =
			$DB->fetch_one(sprintf($this->SQL_GET_DOMAIN_INFO, $this->domain));

		return $this->info;
	}

	function get_info_by_id ($id) {
		$DB = new MySQLdb;

		$this->info =
			$DB->fetch_one(sprintf($this->SQL_GET_DOMAIN_INFO_BY_ID, $id));

		return $this->info;
	}

	function get_info_by_no ($no) {
		$DB = new MySQLdb;

		$this->info =
			$DB->fetch_one(sprintf($this->SQL_GET_DOMAIN_INFO_BY_NO, $no));

		return $this->info;
	}

	function get_info_by_www_name ($domain_name) {
		$DB = new MySQLdb;

		$this->info =
			$DB->fetch_one(sprintf($this->SQL_GET_DOMAIN_INFO_BY_WWW_NAME, $domain_name));

		return $this->info;
	}

	function get_alias ($id="") {
		if (! $id) $id = $_SESSION["config_id"];

		$DB = new MySQLdb;

		$DB->fetch_query(sprintf($this->SQL_GET_DOMAIN_ALIAS, $id), true);

		for ($i = 0; $i < $DB->num_rows; $i++) {
			$o = $DB->fetch();
			$a[] = $o["name"];
		}

		if (count($a) < 1) {
			$retval = array();
		} else {
			$retval = $a;
		}

		return $retval;
	}

	function is_duplicated_alias ($name, $id="") {

		if (! $id) $id = $_SESSION["config_id"];

		$DB = new MySQLdb;

		$o = $DB->fetch_one(sprintf($this->SQL_COUNT_DOMAIN_ALIAS, $id));

		if (intval($o["num"]) < 1) {
			$retval = false;
		} else {
			$retval = true;
		}

		return $alias;
	}

	function get_all_table () {
		global $table;

		$DB = new MySQLdb;

		$DB->query(
			sprintf("select id from user_priv where domain = '%s'",
				$_SESSION["config_domain"]),
			true);

		for ($i = 0; $i < $DB->num_rows; $i++) {
			$o = $DB->fetch();

			$ids[] = $o["id"];
		}

		// get user tables
		while (list($i, $j) = each($ids)) {
			reset($table["user"]);
			while (list($k, $l) = each($table["user"])) {
				$table_list[] = sprintf("%s_%s", $k, $j);
			}
		}

		// get domain tables
		$table_list[] = sprintf("mail_filter_%s", $_SESSION["config_id"]);
		$table_list[] = sprintf("mail_block__%s", $_SESSION["config_id"]);

		return $table_list;
	}

}

/*
Description
-----------

Author
------
 Spike^ekipS <spike@spikeekips.net>

Changelog
---------

Usage
-----

*/

?>
