<?

include_once $global["root"] . "/lib/Mail.php";
include_once $global["root"] . "/lib/Request.php";
include_once $global["root"] . "/lib/Directories.php";
include_once $global["root"] . "/lib/Modules.php";

class Menu {

	var $Template;

	function Menu () {
		$this->Template = new Template;
	}

	function system () {
		global $global;

		if ($_SESSION["config_global"]) {
			$retval = $this->system_global();
		} else {
			$retval = $this->system_user();
		}

		return $retval;
	}

	function system_global () {
		$retval = $this->Template->generate("global/global/menu_system");
		return $retval;
	}

	function system_user () {
		global $global, $string;

		$main = array_flip($_SESSION["user_item_type"]);

		if (check_newmail($global["directory"]["tmp"])) {
			$main["tmpmail_alert"] =
				sprintf("<a class=\"mesian\" href=\"%s/mail.php?mode=list&no=%s\"><img class=\"mesian\"
					src=\"%s/message/image/tmpmail_alert.gif\" title=\"%s\"></a>",
					$_SESSION["user_global_url"], $global["directory"]["tmp"],
					$_SESSION["user_theme_url"], $string["message59"]);

			$system_menu["directory3"] = $string["directory3"];
		}

		if (check_newmail($global["directory"]["inbox"])) {
			$main["newmail_alert"] =
				sprintf("<a class=\"mesian\" href=\"%s/mail.php?mode=list&no=%s\"
						><img class=\"mesian\"
						src=\"%s/message/image/newmail_alert.gif\" title=\"%s\"></a>",
					$_SESSION["user_global_url"], $global["directory"]["inbox"],
					$_SESSION["user_theme_url"], $string["message58"]);

			$main["directory1"] = $string["directory1"];
		}

		$retval =
			$this->Template->generate("global/menu_system", $main);

		return $retval;
	}

	function directory() {

		$Directories = new Directories();

		$retval = $Directories->return_menu($_SESSION["user_directory"]);

		return $retval;
	}

	function module () {

		$Modules = new Modules();
		$retval = $Modules->return_menu();

		return $retval;
	}

	function main () {

		switch ($_SESSION["tmp"]["menu"]) {

			case ("doc") :
				$retval = $this->menu_doc();
			break;

			case ("card") :
				$retval = $this->menu_card();
			break;

			default :
				$REQ = new Request;
				if ( in_array($_GET["mode"], $REQ->control_request)) {
					$retval = $this->menu_control();
				} else {
					$retval = $this->menu_user();
				}
		}

		return $retval;
	}

	function menu_control () {
		if (! $_SESSION["user_is_postmaster"]) {
			$retval = $this->__menu_control_user();
		} else {
			$retval = $this->__menu_control_postmaster();
		}

		return $retval;
	}

	function __menu_control_postmaster () {
		$retval = $this->Template->generate("global/domain/menu_control");
		return $retval;
	}

	function __menu_control_user () {
		$retval = $this->Template->generate("global/menu_control");
		return $retval;
	}

	function menu_user () {
		$menu["directory"] = $this->directory();
		$menu["module"] = $this->module();

		$retval = $this->Template->generate("global/menu", $menu);

		return $retval;
	}

	function menu_card () {
		global $global;

		include_once $global["root"] . "/lib/Extend_card.php";

		$C = new Extend_card;

		$menu["directory"] = $C->return_menu ();
		$menu["module"] = $this->module();

		$retval = $this->Template->generate("global/menu", $menu);


		return $retval;
	}

	function menu_doc () {
		global $global;

		include_once $global["root"] . "/lib/Extend_doc.php";

		$Doc = new Extend_doc;

		$menu["directory"] = $Doc->return_menu ();
		$menu["module"] = $this->module();

		$retval = $this->Template->generate("global/menu", $menu);


		return $retval;
	}
}


/*
Description
-----------

Author
------
 Spike^ekipS <spike@spikeekips.net>

Changelog
---------

Usage
-----

*/

?>
