<?
include_once $global["root"] . "/lib/Directory.php";
include_once $global["root"] . "/lib/Module.php";
include_once $global["root"] . "/lib/Page.php";
include_once $global["root"] . "/lib/Directories.php";

class Search {

	var $Template;
	var $str;
	var $depth;

	var $SQL_GET_ITEMS = "select SQL_CACHE no, item_num, item_type, directory_num
		from item_%s where %s";

	function Search ($str="") {
		$this->Template = new Template;

		if (trim($str) != "" and $str) $this->str = $str;
	}

	function return_form () {
		global $global, $string;

		$aa = $_SESSION["user_item_type"];
		while (list($i, $j) = each($aa)) {
			if ($i == "2") {
				$a .=
					sprintf("<option value=\"%s\" selected>
						&nbsp;%s&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;",
						$i, $string["module"][$j]) . "\n";
			} else {
				$a .= sprintf("<option value=\"%s\">&nbsp;%s",
						$i, $string["module"][$j]) . "\n";
			}
		}

		$main["item_types"] =
			sprintf("<select multiple size=\"%s\" name=\"modules[]\">%s</select>",
				count($_SESSION["user_item_type"]) + 1, $a);

		$main["str"] = $this->str;

		$main["select_directory"] = $this->return_select_box();

		$retval = $this->Template->generate("item/search_form", $main);

		return $retval;
	}

	function return_result ($modules, $case="", $directory_num="", $pg="0") {
		global $global, $string;

		if (! $case or $case == "") $case = "0";
		if (! $pg) $pg = intval("0");

		while (list($i, $j) = each($directory_num)) {
			$a[] = sprintf("directory_num = '%s'", $j);
		}

		$directories = implode(" or ", $a);

		unset($a);
		while (list($i, $j) = each($modules)) {
			$a[] = sprintf("item_type = '%s'", $j);
		}

		$m_list = implode(" or ", $a);
		unset($a);

		$add_query = sprintf("(%s) and (%s)", $directories, $m_list);

		$DB = new MySQLdb;
		$DB->query(sprintf($this->SQL_GET_ITEMS,
			$_SESSION["config_id"], $add_query), true);

		$data = array();
		for ($i = 0; $i < $DB->num_rows; $i++) {
			$o = $DB->fetch();

			$data_order[] = $o["no"]; // for list order.

			$data[$o["item_type"]][$o["item_num"]]["no"] = $o["no"];
			$data[$o["item_type"]][$o["item_num"]]["directory_num"] = $o["directory_num"];
		}

		if (count($data) < 1) {

			$main["content"] =
				$this->Template->generate("item/search_result_empty");
		} else {

			$input = array();

			$M = new Module;
			$module_list = array_keys($data);

			while (list($i, $j) = each($module_list)) {
				$M->item_type = $j;
				$n = $M->execute3("search_array", $this->str, $data[$j], $case);

				if (! is_array($n) or count($n) < 1) continue;
				$input += $n;
			}

			if (count($input) < 1) {
				$main["content"] =
					$this->Template->generate("item/search_result_empty");
			} else {

				reset($input);
				krsort($input);

				// paging
				$Page = new Page_search($pg, count($input));
				$pg = $Page->page_current; // for over-page.

				$main["page_list"] = $Page->print_list();

				$item_start = $pg * $_SESSION["config_pageLimit"];
				$item_end = $item_start + $_SESSION["config_pageLimit"];

				$n = 0;

				$Item = new Item;
				while (list($i, $j) = each($input)) {

					if ($n < $item_start) {
						$n += 1;
						continue;
					}

					if ($n > $item_end) break;

					$Item->set($i, $j["no"], $j["item_type"]);

					$o = $Item->info();
					if (! $o["createdTime"]) continue;

					$n += 1;

					$one["title"] =
						sprintf("<a class=\"mesian_bold\"
							href=\"%s/mail.php?no=%s&mode=search_view\">%s</a>",
							$_SESSION["user_global_url"], $i, $o["title"]);

					$one["icon"] =
						sprintf("<img class=\"mesian\"
							src=\"%s/%s/image/content_type-25.png\">",
							$_SESSION["user_theme_url"],
							$_SESSION["user_item_type"][$j["item_type"]],
							$_SESSION["user_item_type"][$j["item_type"]]
						);

					if ($o["author"]["short"]) {
						$one["author"] = $o["author"]["short"];
					} else {
						$one["author"] = $o["author"]["full"];
					}

					if ($o["author"]["short"]) {
						$one["author"] =
							sprintf("<a class=\"mesian\"
								href=\"%s/mail.php?mode=address_action&address=%s&no=%s&name=%s\"
								title=\"%s\">%s</a>",
								$_SESSION["user_global_url"],
								$o["author"]["full"],
								$o["no"],
								$o["author"]["short"],
								$string["message93"],
								$o["author"]["short"]
							);
					} else {
						$one["author"] = $o["author"]["full"];
					}

					$one["createdTime"] =
						print_time($o["createdTime"], $_SESSION["config_lang"]);
					$main["content"] .=
						$this->Template->generate("item/search_result_line", $one);
				}
			}
		}

		$main["str"] = $this->str;

		$retval =
			$this->Template->generate("item/search_result", $main);

		return $retval;
	}

	function return_select_box () {
		global $global, $string;

		$Directory = new myDirectory();
		$Directory->no = "0";
		$a = $Directory->get_info_subdirectory();

		//-------------------------------------------------- module directory.
		$Directories = new Directories;

		while (list($i, $j) = each($a)) {
			unset($c);

			$Directory->no = $i;

			$c["num"] = $i;
			$c["name"] = $Directory->get_name();
			$c["icon"] = $Directories->set_icon($i);

			$main["content"] .=
				$this->Template->generate(
					"item/directory_select_box_list_line_search", $c);

			$this->depth = 1;
			$main["content"] .= $this->return_select_box_sub($i);
		}

		$template = "item/directory_select_box_list_search";

		$retval = $this->Template->generate($template, $main);

		return $retval;
	}

	function return_select_box_sub ($parent="0") {
		global $global, $string;

		$Directory = new myDirectory();
		$Directories = new Directories();

		$Directory->no = $parent;
		$a = $Directory->get_info_subdirectory();

		if (!is_array($a)) {
			$retval = "";
		} else {

			$c["depth"] = $this->depth * 15;

			$depth = $this->depth;
			while (list($i, $j) = each($a)) {
				$c["num"] = $i;
				$c["name"] = $j["name"];
				$c["icon"] = $Directories->set_icon($i);

				// icon.
				$main["content"] .=
					$this->Template->generate(
						"item/directory_select_box_list_line_search", $c);

				$this->depth = $depth + 1;
				$main["content"] .= $this->return_select_box_sub ($i);
			}
			$retval = $main["content"];
		}

		return $retval;
	}

}


/*
Description
-----------

Author
------
 Spike^ekipS <spike@spikeekips.net>

Changelog
---------

Usage
-----

*/

?>
