# -*- coding: utf-8 -*-
import sys, time, sha, random, string

#---------------------------------------------------------------- environment checking
if len(sys.argv) < 2 or not sys.stdin :
	sys.exit(1)

#--------------------------------------------------- parse mail address, sys.argv[1]
message_id = sha.new("%s.%s" % (int(time.time()), str(random.random()))).hexdigest()
filename = "%s-%s" % (sys.argv[1], message_id)

import config, Log

if config.file["scanner"] :
	save_directory = config.qmail["directory"]["message_tmp"]
else :
	save_directory = config.qmail["directory"]["message"]

try :
	sf = open("%s/%s" % (save_directory, filename), "w")
except :
	msg_error = "Failed to save message in %s" % config.qmail["directory"]["message"]

	L = Log.Log("savemail")
	L.info(msg_error)
	raise ValueError, msg_error
else :
	P_address = sys.argv[1].split("@")

	sf.write("".join(sys.stdin.readlines()))
	sf.close()
	L = Log.Log("domain/%s" % string.lower(P_address[1]))
	L.info("To %s, %s was saved." % (P_address[0], message_id))

sys.exit(0)

__author__ =  "Spike^ekipS <spike@spikeekips.net>"
__version__=  "0.1"
__nonsense__ = ""

__file__ = "savemail.py"

