<?
// Wriiten by Spike^ekipS <spike@spikeekips.net>

include_once "./setting.php";

// include
include_once $global["root"] . "/include/handle.php";
include_once $global["root"] . "/include/print_array.php";

// lib
include_once $global["root"] . "/lib/Site.php";
include_once $global["root"] . "/lib/Authentication.php";
include_once $global["root"] . "/lib/User.php";
include_once $global["root"] . "/lib/Address.php";
include_once $global["root"] . "/lib/Domain.php";

if (! $_POST["no"]) {
	goprev();
}

$Site = new Site;
$Site->init("_GET");
$Site->set_permission("global");

extract($_POST);

include_once $global["lang"] . "/" . $_SESSION["config_lang"] . ".php";

// check valiue
while (list($i, $j) = each($_POST)) {
	if (! ereg("^M_", $i) and ! ereg("^N_", $i)) continue;

	if (intval($j) < 1) {
		$_SESSION["tmp"]["msg"]["content"] = $string["error33"];
		$Site->end1();
		goprev();
	}

	if (! is_int(intval($j))) continue;

	if (ereg("^M_", $i)) {
		$a[] = sprintf("%s = '%s'", ereg_replace("^M_", "", $i), intval(($j * 1000000)));

		$u_set[] = sprintf("%s = '%s'", ereg_replace("^M_", "", $i), intval(($j * 1000000)));
		$u_where[] =
			sprintf("%s > '%s'", ereg_replace("^M_", "", $i), intval(($j * 1000000)));

	} else if (ereg("^N_", $i)) {
		$a[] = sprintf("%s = '%s'", ereg_replace("^N_", "", $i), $j);

		if ($i != "N_user_limit") {
			$u_set[] = sprintf("%s = '%s'", ereg_replace("^N_", "", $i), $j);
			$u_where[] =
				sprintf("%s > '%s'", ereg_replace("^N_", "", $i), $j);
		}
	}
}

if ($_POST["theme"]) $a[] = sprintf("theme = '%s'", escape_string($_POST["theme"]));
if ($_POST["lang"]) $a[] = sprintf("lang = '%s'", escape_string($_POST["lang"]));

// domain alias check.
$Domain = new Domain;
$domain_id = $Domain->get_id_by_no($_POST["no"]);

if (trim($_POST["domain_alias"]) != "") {
	$Address = new Address;
	if (! $Address->check_valid_domain(trim($_POST["domain_alias"]))) {
		$_SESSION["tmp"]["msg"]["content"] = $string["error31"];
		$Site->end1();
		goprev();
	}

	// domain alais
	if ($Domain->is_duplicated_alias(trim($_POST["domain_alias"]), $domain_id)) {
		$_SESSION["tmp"]["msg"]["content"] = $string["error23"];
		$Site->end1();
		goprev();
	} else {
		$query_domain_alias = sprintf(
				"insert into domain_alias_priv (name, domain_id, valid)
					values('%s', '%s', '1')",
				escape_string(trim($_POST["domain_alias"])), $domain_id);
	}
}

// check password
if (trim($_POST["password_two"]) != "") {
	if (strcmp($_POST["password_one"], $_POST["password_two"]) === 0) {
		$a[] = sprintf("password = sha('%s')", $_POST["password_two"]);
	} else {
		$_SESSION["tmp"]["msg"]["content"] = $string["error21"];
		$Site->end1();
		goprev();
	}
}

$Site->DB->transaction_start(true);
$Site->DB->execute_query(sprintf("update domain_priv set %s where no = '%s'",
	implode(", ", $a), $_POST["no"]));

$retval = $Site->DB->retval;

if ($query_domain_alias and $retval) $Site->DB->execute_query($query_domain_alias);

$retval = $Site->DB->retval;

if ($retval) {
	// reset the the limit of user configuration.
	$domain_info = $Domain->get_info_by_no($_POST["no"]);

	while (list($i, $j) = each($u_set)) {
		$query_user[] =
			sprintf("update user_priv set %s where %s and domain = '%s'",
				$j, $u_where[$i], $domain_info["name"]);
	}

	while (list($i, $j) = each($query_user)) {
		$Site->DB->query($j);
	}
}

//$retval = $Site->DB->retval;

// reassign session value.
$Site->DB->close();

if ($retval) {
	$_SESSION["tmp"]["msg"]["content"] = $string["msg"];
	$_SESSION["tmp"]["msg"]["type"] = "2";

	$url = sprintf("Location: %s/global.php?mode=domain&no=%s",
		$_SESSION["user_global_url"], $_POST["no"]);

	$Site->end1();
	Header($url);
	exit;
} else {
	$_SESSION["tmp"]["msg"]["content"] = $string["msg1"];
	$Site->end1();
	goprev();
}

/*
Description
-----------

Author
------
 Spike^ekipS <spike@spikeekips.net>

Changelog
---------

Usage
-----

*/

?>
