<?

include_once $global["root"] . "/lib/Doc_Group.php";

class Basic_Doc_Group {

	var $SQL_UPDATE_DOC_GROUP = "update doc_group_%s set item = '%s' where no = '%s'";
	var $SQL_ADD_GROUP = "insert into doc_group_%s (name) values ('%s')";
	var $SQL_RENAME_GROUP = "update doc_group_%s set name = '%s' where no = '%s'";
	var $SQL_REMOVE_GROUP = "delete from doc_group_%s where no = '%s'";

	function add ($name) {

		if (trim($name) == "") {
			$retval = false;
		} else {
			$DB = new MySQLdb;

			$name = escape_string(trim($name));

			$DB->execute_query(
				sprintf($this->SQL_ADD_GROUP, $_SESSION["config_id"], $name)
			);

			$retval = $DB->retval;
		}

		return $retval;
	}

	function rename ($no, $name) {
		if (trim($name) == "") {
			$retval = false;
		} else {
			$DB = new MySQLdb;

			$name = escape_string(trim($name));

			$DB->execute_query(
				sprintf($this->SQL_RENAME_GROUP, $_SESSION["config_id"], $name, $no)
			);

			$retval = $DB->retval;
		}

		return $retval;
	}

	function remove ($no) {

		$DB = new MySQLdb;

		$DB->execute_query(
			sprintf($this->SQL_REMOVE_GROUP, $_SESSION["config_id"], $no)
		);

		$retval = $DB->retval;

		return $retval;
	}

	function move_item ($src_group_no, $dst_group_no, $items) {

		$retval = $this->remove_item($src_group_no, $items);

		if ($retval) {
			$retval = $this->add_item($dst_group_no, $items);
		}

		return $retval;
	}

	function remove_item_in_all_group ($items) {
		global $global;

		include_once $global["root"] . "/lib/Item.php";

		$Doc = new Doc_Group;
		$list = $Doc->get_list();

		// remove this items in group.
		$retval = true;
		while (list($i, $j) = each($list)) {
			if ($retval) $retval = $this->remove_item($i, $items);
		}

		// remove this items in item_%s really.
		if ($retval) {
			$list = __return_array_for_group_item($items);
			$Item = new Item;

			while (list($i, $j) = each($list)) {
				$item_no = $Item->get_no($j, $_SESSION["user_item_type_rv"]["doc"]);

				$Item->set($item_no, $j, $_SESSION["user_item_type_rv"]["doc"]);
				$Item->remove();
			}
		}

		return $retval;
	}

	function remove_item ($group_no, $items) {

		// get item list from group_no.
		$Doc = new Doc_Group;
		$o = $Doc->get_info($group_no);

		// generate item list.
		if (! is_array($o["item"])) {
			$retval = true;
		} else {

			if (count(__return_array_for_group_item($o["item"])) < 1) {
				$retval = true;

			} else {
				$var =
					__remove_item(__return_array_for_group_item($items), $o["item"]);

				$DB = new MySQLdb;

				$DB->query(sprintf(
						$this->SQL_UPDATE_DOC_GROUP, $_SESSION["config_id"],
						sprintf(",%s", implode(",", $var)),
						$group_no
					)
				);

				$retval = $DB->retval;
			}
		}

		return $retval;
	}

	function add_item ($group_no, $items) {

		// get item list from group_no.
		$Doc = new Doc_Group;
		$o = $Doc->get_info($group_no);

		// generate item list.
		$var = __add_item($o["item"],
			__return_array_for_group_item($items));

		$DB = new MySQLdb;

		$query = sprintf(
				$this->SQL_UPDATE_DOC_GROUP, $_SESSION["config_id"],
				sprintf(",%s", implode(",", $var)),
				$group_no);

		$DB->query($query);

		$retval = $DB->retval;

		return $retval;
	}

}

/*
Description
-----------

Author
------
 Spike^ekipS <spike@spikeekips.net>

Changelog
---------

Usage
-----

*/

?>
